
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Sounds = {}
Sounds.__index = Sounds

-- =======================================================================

function Sounds.new()

	local new = {}
	setmetatable(new, Sounds)
	
	new.sounds = Map.new()
	new:Load()

	return new

end

-- =======================================================================

function Sounds:Load()

	--self:LoadSound('ID', 'sound.wav')

end

-- =======================================================================

function Sounds:LoadSound (ID, sourceFilePath)
	
	assert(not self.sounds:ContainsKey(ID), strFormat("Duplicate sound ID '%s'.", ID))

	local sound = love.audio.newSource('assets/sounds/' .. sourceFilePath)
	self.sounds[ID] = sound

end

-- =======================================================================

function Sounds:PlaySound (ID)

	local sound = assert(self.sounds[ID], strFormat("Sound with ID '%s' doesn't exist.", ID))
	love.audio.play(sound)

end

