
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

CameraControl = {}
CameraControl.__index = CameraControl

-- =======================================================================

function CameraControl.new()

	local new = {}
	setmetatable(new, CameraControl)
	
	new.posX = 0
	new.posY = 0

	new:Hook()

	return new

end

-- =======================================================================

function CameraControl:Hook()

	networkScreen:GetMouseEvents().onMouseMove:Subscribe(self)
	
end

-- =======================================================================

function CameraControl:StartMousePull()

	self.pull = true
	networkScreen:ReceiveTutorialImpulse(TutorialImpulse.ViewportMove, {})

end

-- =======================================================================

function CameraControl:EndMousePull()

	self.pull = nil

end

-- =======================================================================

function CameraControl:OnMouseMove (mouseMoveData)

	if self.pull then

		self.posX = self.posX - mouseMoveData.dX
		self.posY = self.posY - mouseMoveData.dY

	end

end

-- =======================================================================

function CameraControl:SetPos (posX, posY)

	self.posX = posX
	self.posY = posY

end

-- =======================================================================

function CameraControl:GetPosX()

	return self.posX

end

-- =======================================================================

function CameraControl:GetPosY()

	return self.posY

end

