
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Keyboard = {}
Keyboard.__index = Keyboard

-- =======================================================================

function Keyboard.new()
	
	local new = {}
	setmetatable(new, Keyboard)

	new.onKeyPress = Notice.new{ methodName = 'OnKeyPress' }
	new.onKeyRelease = Notice.new{ methodName = 'OnKeyRelease' }
	new.onTextInput = Notice.new{ methodName = 'OnTextInput' }
	
	return new

end

-- =======================================================================

function Keyboard:OnKeyPress (key, isRepeat)

	keyboard.onKeyPress:Invoke(key, isRepeat)

end

-- =======================================================================

function Keyboard:OnKeyRelease (key)

	keyboard.onKeyRelease:Invoke(key)

end

-- =======================================================================

function Keyboard:OnTextInput (text)

	keyboard.onTextInput:Invoke(text)

end
