
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Mouse = {}
Mouse.__index = Mouse

-- =======================================================================

function Mouse.new()

	local new = {}
	setmetatable(new, Mouse)
	
	return new

end

-- =======================================================================

function Mouse:SetEvents (events)

	self.events = events

end

-- =======================================================================

function Mouse:OnFrameStart()

	local newCurX, newCurY = love.mouse.getPosition()

	if self.curX == nil then

		self.curX = newCurX
		self.curY = newCurY
		return

	end

	if newCurX == self.curX and newCurY == self.curY then
		return
	end

	local mouseMoveData = { curX = newCurX, curY = newCurY }
	mouseMoveData.dX = newCurX - self.curX
	mouseMoveData.dY = newCurY - self.curY

	self.curX = newCurX
	self.curY = newCurY

	self.events.onMouseMove:Invoke(mouseMoveData)

end

-- =======================================================================

function Mouse:OnMouseButtonPress (button, curX, curY)

	self.events.onMouseButtonPress:Invoke(button, curX, curY)

end

-- =======================================================================

function Mouse:OnMouseButtonRelease (button, curX, curY)

	self.events.onMouseButtonRelease:Invoke(button, curX, curY)

end

-- =======================================================================

function Mouse:GetCursorPos()

	return self.curX, self.curY

end

-- =======================================================================

function Mouse:GetCursorX()

	return self.curX

end

-- =======================================================================

function Mouse:GetCursorY()

	return self.curY
	
end
