
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local builder = CharacterBuilder:NewClass
{
	ID = 'halrow-lamarche:administrator',
	role = 'corporate-administrator'
}

-- =======================================================================

-- [Base Character builder override]
function builder:Construct()

	self:CreateCoordinateEvents()
	
	self:CreateAccountSiphonEvents()
	
	self:CreatePurchaseEvent()
	self:CreateDeteriorateRelationshipEvent()
	self:CreateLeaveEvent()
	
	self:CreateIntroductionEvent()

end

-- =======================================================================

function builder:CreateCoordinateEvents()

	local character = self.character

	local event = character:NewEvent('halrow-lamarche:administrator:create-coordinate', {})
	event:SetChance(random:Value(0.15, 0.35))

	for _ = 1, random:IntValue(3, 5) do
		event:Invoke()
	end

	event = character:NewEvent('vendor:prune-items', { class = ItemClass.Coordinate })
	event:SetChance(random:Value(0.05, 0.1))

end

-- =======================================================================

function builder:CreateAccountSiphonEvents()

	local character = self.character
	character:NewEvent('halrow-lamarche:administrator:account-siphon:start', {})
	character:NewEvent('halrow-lamarche:administrator:account-siphon:success', {})
	character:NewEvent('halrow-lamarche:administrator:account-siphon:fail', {})

end

-- =======================================================================

function builder:CreatePurchaseEvent()
	
	local character = self.character
	character:NewEvent('vendor:increase-relationship-on-purchase', { mod = random:Value(0.0015, 0.0025) })

end

-- =======================================================================

function builder:CreateDeteriorateRelationshipEvent()
	
	local character = self.character
	character:NewEvent('common:relationship:deteriorate-with-time', { mod = random:Value(0.25, 0.75) })

end

-- =======================================================================

function builder:CreateLeaveEvent()

	local character = self.character
	character:NewEvent('common:relationship:leave-when-low', {})

end

-- =======================================================================

function builder:CreateIntroductionEvent()

	local character = self.character
	character:NewEvent('halrow-lamarche:administrator:introduction:administrator', {})

end

