
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local builder = CharacterBuilder:NewClass
{
	ID = 'street:data-broker',
	role = 'data-broker'
}

-- =======================================================================

function builder:Construct()

	local character = self.character
	character:MakeAcceptData()

	self:CreateDataSellEvent()
	self:CreateDeteriorateRelationshipEvent()
	self:CreateLeaveEvent()

	self:CreateIntroductionEvent()

end

-- =======================================================================

function builder:CreateDataSellEvent (context)
	
	local character = self.character
	character:NewEvent('vendor:increase-relationship-when-data-sold', { mod = 0.0015 })

end

-- =======================================================================

function builder:CreateDeteriorateRelationshipEvent()
	
	local character = self.character
	character:NewEvent('common:relationship:deteriorate-with-time', { mod = random:Value(0.15, 0.5) })

end

-- =======================================================================

function builder:CreateLeaveEvent()

	local character = self.character
	character:NewEvent('common:relationship:leave-when-low', {})

end

-- =======================================================================

function builder:CreateIntroductionEvent()

	local character = self.character
	character:NewEvent('street:introduction:switch', {})

end

