
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local builder = CharacterBuilder:NewClass
{
	ID = 'street:module-dealer',
	role = 'module-dealer'
}

-- =======================================================================

function builder:Construct()

	self:CreateStockEvent()
	self:CreatePruneEvent()
	self:CreatePurchaseEvent()
	self:CreateDeteriorateRelationshipEvent()
	self:CreateLeaveEvent()
	self:CreateIntroductionEvent()

end

-- =======================================================================

function builder:CreateStockEvent()

	local rank = self.details['rank']
	local character = self.character

	-- All modules
	local items = Collection.new()
	items:Add(Values.new({ item = '{ebe3a219-5a69-4f56-81f9-6341c6f2b846}', rank = 1, chance = 10, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{2ac3ea8e-493a-4029-9dfa-3d91769392d4}', rank = 1, chance = 50, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{597f7d8e-948d-45b6-9844-2a433ec3e8eb}', rank = 1, chance = 10, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{73750128-630e-4b3e-a865-9b2147ef5214}', rank = 1, chance = 10, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{751970ca-e871-4ff2-af33-9b91d0b571de}', rank = 1, chance = 25, price_base = 25, price_random = 10 }))
	items:Add(Values.new({ item = '{ca6add11-d2ed-11e3-9c1a-20ab7e004562}', rank = 1, chance = 20, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{ceee7b53-cb2c-490b-b78c-24d26d0bab08}', rank = 1, chance = 20, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{461c104a-b0a3-4701-9c5a-19f4a9c21ccb}', rank = 1, chance = 35, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{dcf63bbb-6e81-4f6f-97c1-fcdbccbdda0b}', rank = 1, chance = 10, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{6064bbf6-c071-4718-b882-77f19b549d1e}', rank = 1, chance = 20, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{dceff74a-747b-4bdf-8eff-1992176a2dac}', rank = 1, chance = 10, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{d1b08a21-51cf-4b8c-bbad-2396aab9b0d5}', rank = 1, chance = 10, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{da2db277-fcf2-4dac-bcdd-379d4c61fe22}', rank = 1, chance = 10, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{9c54e5c4-26d3-418c-ae3c-8b927ec14b70}', rank = 1, chance = 10, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{6fe96f9c-a78c-4529-89d3-ef5775afd2d9}', rank = 1, chance = 00, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{cae68356-ed33-4ad2-973e-cefb49ad9f2f}', rank = 1, chance = 35, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{d30f2e71-950b-4366-b26e-e3f22f51fd53}', rank = 1, chance = 10, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{c4f2db4b-0252-43fc-ac83-617736586173}', rank = 1, chance = 10, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{bfed5cbd-51cb-4128-a969-47c06de5b6b1}', rank = 1, chance = 25, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{932d9ecf-6668-482c-854d-8addae02a8dc}', rank = 1, chance = 25, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{aeec997f-32df-4c1e-8140-6715a7745d27}', rank = 1, chance = 35, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{96114876-1a81-42bb-af2e-f3271e5bf637}', rank = 1, chance = 10, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{a515d826-4fc0-4d25-83c9-2f699dd6869b}', rank = 1, chance = 10, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{535a8ece-f25d-4aff-b022-379f3723aaae}', rank = 1, chance = 10, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{6e8ad689-8ae7-48cc-b972-0b4cf5bf9bf2}', rank = 1, chance = 10, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{10b6dbd9-48d5-46a2-9f98-e55c490c765b}', rank = 1, chance = 10, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{4f0bf92b-c3e2-4f1d-9d4b-6f37eacdf86e}', rank = 1, chance = 10, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{13aee470-8832-46e0-9e06-985ce06a540d}', rank = 1, chance = 65, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{0bdf7e7f-73b9-4c0a-b4d6-0f060d0df94f}', rank = 1, chance = 35, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{89575252-49e6-48c4-9a2e-89b77d68b614}', rank = 1, chance = 25, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{571a384b-13b6-4a5b-908e-32dcfed1dcf0}', rank = 1, chance = 10, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{3614c794-427d-4e9c-b178-4b086f5a7174}', rank = 1, chance = 15, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{673fe5ca-58a7-4e88-b133-8851835add08}', rank = 1, chance = 45, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{11d727cf-9544-4b10-b0e4-9f890825619b}', rank = 1, chance = 15, price_base = 20, price_random = 15 }))
	items:Add(Values.new({ item = '{fab10268-f24a-458f-a284-ca34fd743dcc}', rank = 1, chance = 15, price_base = 10, price_random = 5 }))
	items:Add(Values.new({ item = '{0c0a9746-b09e-422f-a1b4-7ae1b6fb0c0f}', rank = 1, chance = 10, price_base = 10, price_random = 5 }))

	-- Create the event
	local pool = CharacterBuilder.Utils.BuildItemPool(items, rank, random:IntValue(15, 25))
	local event = character:NewEvent('vendor:stock-items', { pool = pool, class = ItemClass.Module, allow_duplicates = false, price_unit = 250 })
	event:SetChance(random:Value(0.65, 0.75))

	-- Init stock
	for _ = 1, random:IntValue(8, 12) do
		event:Invoke()
	end

end

-- =======================================================================

function builder:CreatePruneEvent()
	
	local character = self.character

	local event = character:NewEvent('vendor:prune-items', { class = ItemClass.Module })
	event:SetChance(random:Value(0.3, 0.4))

end

-- =======================================================================

function builder:CreatePurchaseEvent()
	
	local character = self.character
	character:NewEvent('vendor:increase-relationship-on-purchase', { mod = random:Value(0.0015, 0.0025) })

end

-- =======================================================================

function builder:CreateDeteriorateRelationshipEvent()
	
	local character = self.character
	character:NewEvent('common:relationship:deteriorate-with-time', { mod = random:Value(0.25, 0.75) })

end


-- =======================================================================

function builder:CreateLeaveEvent()

	local character = self.character
	character:NewEvent('common:relationship:leave-when-low', {})

end

-- =======================================================================

function builder:CreateIntroductionEvent()

	local character = self.character
	character:NewEvent('street:introduction:switch', {})

end

