
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local effect = Effect:NewClass
{ 
	ID = 'omniport',
	events = 
	{
		{ ID = 'access', time = 0.45 },
		{ ID = 'trace', time = 0.65 },
		{ ID = 'alert', time = 0.85 }
	}
}

-- =======================================================================

function effect:Draw (screenX, screenY)

	-- ===
	-- TEMP
	-- ===

	if self.sprite == nil then

		self.sprite = love.graphics.newImage('assets/sprites/modules/omniport.png')

	end

	local spriteSizeX = self.sprite:getWidth()
	local spriteSizeY = self.sprite:getHeight()

	local sizeX = 128
	local sizeY = 128

	local time = self.time

	local rot = time * math.pi / 8
	local alpha = 192 - math.min(time / 1, 1) * 192
	local b = 232
	local white = math.max(128 - time * 232, 0)

	for orientation = -1, 1, 2 do

		love.graphics.setColor(white, white, b, alpha)
		love.graphics.draw(self.sprite, screenX, screenY, rot * orientation, sizeX/spriteSizeX, sizeY/spriteSizeY, spriteSizeX/2, spriteSizeY/2)

	end

end
