
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local event = Event:NewClass
{
	ID = 'botched-operation:introduction',
	impulse = EventImpulse.Tick,
	chance = 0.35,
	format = EventFormat.Selection,
	maxExecutionCount = 1,
	choices = { 'accept', 'dismiss' }
}

-- =======================================================================

function event:Run()
	
	local stash = self:GetStash()

	local builder = CharacterBuilder:NewInstance('botched-operation:character')
	local character = builder:Build()

	stash['character'] = character

end

-- =======================================================================

function event:BuildTextValues()

	local stash = self:GetStash()
	local name = stash['character']:GetName()

	return Values.new{ name = name:GetNominative(), possessive_pronoun = name:GetPossessivePronoun(), person = pick(name:GetSex() == Sex.Male, "man", "woman") }

end

-- CHOICE: ACCEPT ========================================================
-- =======================================================================

event.choice['accept'].execute = function (self)

	local stash = self:GetStash()
	local character = stash['character']

	characters:AddCharacter(character)
	character:AddOperation(OperationBuilder:NewInstance('botched-operation:operation-1', {}):Build())

end
