
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local event = Event:NewClass
{
	ID = 'street:introduction:switch',
	impulse = EventImpulse.Tick,
	chance = 0.15,
	maxExecutionCount = 2,
	cooldown = 12
}

-- =======================================================================

function event:MeetsPrerequisites()

	local character = self.character
	return character:GetRelationship():GetValue() > 25

end

-- =======================================================================

function event:Run (context)
	
	local pool = WeightSet.new()

	pool:Add({ event = 'street:introduction:data-broker' }, 10)
	pool:Add({ event = 'street:introduction:hardware-vendor' }, 10)
	pool:Add({ event = 'street:introduction:module-dealer' }, 10)
	pool:Add({ event = 'street:introduction:shadowrunner' }, 5)

	local choice = pool:Random()
	local e = Event:NewInstance(choice.event, {}, character)
	eventQueue:Push(e, {})

end

