
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local event = Event:NewClass
{
	ID = 'vendor:stock-items',
	impulse = EventImpulse.Tick,
	chance = 0.25
}

-- =======================================================================

function event:Init()
	
	local pool = WeightSet.new()
	for item in self.values['pool']:Each() do

		local chance = item['chance']
		item['chance'] = nil

		pool:Add(item, chance)

	end

	self.values['pool'] = pool

end

-- =======================================================================

function event:Run()
	
	local character = self.character

	local pool = self.values['pool']
	local class = self.values['class']
	local priceUnit = self.values['price_unit']
	local allowDuplicates = self.values['allow_duplicates']

	if pool:GetItemCount() == 0 then
		return
	end

	local poolItem = pool:Random()
	local item = poolItem['item']
	
	if allowDuplicates or (not character:OwnsItem(class, item)) then

		local price = priceUnit * (poolItem['price_base'] + random:IntValue(0, poolItem['price_random']))
		character:AddItem(Item.new(class, item, price))

	end

end

