
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local mod = Module:NewClass
{ 
	ID = '{ebe3a219-5a69-4f56-81f9-6341c6f2b846}', 
	name = "Helix",
	use = ModuleUse.Node,
	nodeClassesLimit = { NodeClass.Router },
	description = "Clears two Alerts on the selected node. Alerts all the connected nodes.",
	tokens = 1
}

-- =======================================================================

function mod:RunOnNode (node)

	self:CreateEffectOnNode('helix-_-center', node)
	for n in node:GetConnectedNodes(NodeClass.Router):Each() do

		self:CreateEffectOnNode('helix-_-leaves', n)

	end

end

-- =======================================================================

mod.handlers['alert'] = function (self, effect)

	local node = effect:GetPivot()
	node:Alert()

end

-- =======================================================================

mod.handlers['clear'] = function (self, effect)

	local node = effect:GetPivot()
	node:ClearAlerts(2)

end

