
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local mod = Module:NewClass
{ 
	ID = '{2ac3ea8e-493a-4029-9dfa-3d91769392d4}', 
	name = "Omniport", 
	use = ModuleUse.Node,
	nodeClassesLimit = { NodeClass.Router },
	description = "Omniport can be used on detected Routers that are still not accessed. Grants Access to the selected node. Provokes a Trace.",
	minNodeVisibility = NodeVisibility.Class,
	maxNodeVisibility = NodeVisibility.Class,
	tokens = 5
}

-- =======================================================================

function mod:RunOnNode (node)
	
	self:CreateEffectOnNode('omniport', node)

end

-- =======================================================================

mod.handlers['access'] = function (self, effect)

	local node = effect:GetPivot()
	node:GainAccess()

end

-- =======================================================================

mod.handlers['trace'] = function (self, effect)

	local node = effect:GetPivot()
	
	local network = self.network
	network:StartTrace(node)

end

-- =======================================================================

mod.handlers['alert'] = function (self, effect)

	local node = effect:GetPivot()
	node:Alert()

end

