
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local mod = Module:NewClass
{ 
	ID = '{ca6add11-d2ed-11e3-9c1a-20ab7e004562}', 
	name = "Oracle", 
	use = ModuleUse.Node,
	nodeClassesLimit = { NodeClass.Router },
	description = "Reveals all subroutines on the selected node and all the connected nodes.",
	traits = { ModuleTrait.Subtle },
	tokens = 2
}

-- =======================================================================

function mod:RunOnNode (node)
	
	self:CreateEffectOnNode('oracle-_-center', node)

	for n in node:GetConnectedNodes(NodeClass.Router):Each() do
		self:CreateEffectOnNode('oracle-_-leaves', n)
	end

end

-- =======================================================================

mod.handlers['reveal'] = function (self, effect)

	local node = effect:GetPivot()
	
	for subroutine in node:GetSubroutines():Each() do
		subroutine:Reveal()
	end

end
