
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local mod = Module:NewClass
{ 
	ID = '{dcf63bbb-6e81-4f6f-97c1-fcdbccbdda0b}', 
	name = "_009", 
	use = ModuleUse.Subroutine,
	description = "Breaks the selected subroutine. {_009} can only be used to break revealed subroutines.",
	tokens = 1
}

-- =======================================================================

function mod:AcceptsSubroutine (subroutine)

	return subroutine:IsRevealed()

end


-- =======================================================================

function mod:RunOnSubroutine (subroutine)
	
	self:CreateEffectOnSubroutine('_009', subroutine)

end

-- =======================================================================

mod.handlers['break'] = function (self, effect)

	local subroutine = effect:GetPivot()
	subroutine:Break(BreakContext.new({}))

end

