
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local mod = Module:NewClass
{ 
	ID = '{dceff74a-747b-4bdf-8eff-1992176a2dac}', 
	name = "Excalibur",
	use = ModuleUse.Node,
	nodeClassesLimit = { NodeClass.Router },
	description = "Breaches the selected node. Excalibur requires one less [T] to use while the deck operates with at least 6[T].",
	staticTokens = 3
}

-- =======================================================================

function mod:GetRequiredTokens()

	local tokens = networkScreen:GetRun():GetTokens()
	return pick(tokens:GetCount() < 6, 3, 2)

end

-- =======================================================================

function mod:RunOnNode (node)

	self:CreateEffectOnNode('excalibur', node)

end

-- =======================================================================

mod.handlers['breach'] = function (self, effect)

	local node = effect:GetPivot()
	node:Breach(BreachContext.new({}))

end

