
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local mod = Module:NewClass
{ 
	ID = '{6fe96f9c-a78c-4529-89d3-ef5775afd2d9}', 
	name = "Phaselock",
	use = ModuleUse.Node,
	nodeClassesLimit = { NodeClass.Router },
	description = "Breaches the selected node. The Phaselock's [T] requirement is reduced by 1[T] whenever it is used and reset to 5[T] when Phaselock is used with a 0[T] cost.",
	tokens = 3
}

-- =======================================================================

function mod:RunOnNode (node)

	self:CreateEffectOnNode('phaselock', node)

	local tokens = self:GetRequiredTokens()
	if tokens > 0 then

		self:ReduceRequiredTokens(1)

	else

		self:SetRequiredTokens(5)

	end

end

-- =======================================================================

mod.handlers['breach'] = function (self, effect)

	local node = effect:GetPivot()
	node:Breach(BreachContext.new({}))

end

