
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local mod = Module:NewClass
{ 
	ID = '{d30f2e71-950b-4366-b26e-e3f22f51fd53}', 
	name = "Evo",
	use = ModuleUse.Node,
	nodeClassesLimit = { NodeClass.Router },
	description = "Breaches the selected node. The Evo's [T] requirement is reduced by 1[T] (down to a 1[T] minimum) whenever it breaches a non-Alerted node.\nAny Trace in the network increases Evo's [T] requirement to 6[T].",
	tokens = 4
}

-- =======================================================================

function mod:RunOnNode (node)

	self:CreateEffectOnNode('evo', node)

end

-- =======================================================================

mod.reactions[ModuleImpulse.Trace] = function (self)

	self:SetRequiredTokens(6)

end

-- =======================================================================

mod.handlers['breach'] = function (self, effect)

	local node = effect:GetPivot()
	
	local alerted = node:IsAlerted()
	local block = node:BlocksAccess()

	node:Breach(BreachContext.new({}))

	if (not alerted) and block and (not node:BlocksAccess()) then

		self:ReduceRequiredTokens(1, 1)

	end

end

