
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local mod = Module:NewClass
{ 
	ID = '{c4f2db4b-0252-43fc-ac83-617736586173}', 
	name = "Leviathan", 
	use = ModuleUse.Node,
	nodeClassesLimit = { NodeClass.Router },
	description = "Removes one Perimeter protection on the selected node.",
	tokens = 1
}

-- =======================================================================

function mod:AcceptsNode (node) 

	return node:HasPerimeter()

end

-- =======================================================================

function mod:RunOnNode (node)
	
	self:CreateEffectOnNode('leviathan', node)

end

-- =======================================================================

mod.handlers['remove-perimeter'] = function (self, effect)

	local node = effect:GetPivot()
	node:ReducePerimeter()

end

