
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local mod = Module:NewClass
{ 
	ID = '{96114876-1a81-42bb-af2e-f3271e5bf637}', 
	name = "White Lotus", 
	use = ModuleUse.Node,
	nodeClassesLimit = { NodeClass.Router },
	description = "Generates 2[T] per Router connected to the selected node. Provokes a Trace. Alerts the node and all the connected nodes.",
	traits = { ModuleTrait.Subtle }
}

-- =======================================================================

function mod:RunOnNode (node)

	self:CreateEffectOnNode('white-lotus-_-center', node)
	for n in node:GetConnectedNodes(NodeClass.Router):Each() do
		
		self:CreateEffectOnNode('white-lotus-_-leaves', n)

	end

end

-- =======================================================================

mod.handlers['alert'] = function (self, effect)

	local node = effect:GetPivot()
	node:Alert()

end

-- =======================================================================

mod.handlers['tokens'] = function (self, effect)

	local node = effect:GetPivot()

	local tokens = networkScreen:GetRun():GetTokens()
	tokens:Add(2 * #node:GetConnectedNodes(NodeClass.Router))

end

-- =======================================================================

mod.handlers['trace'] = function (self, effect)

	local node = effect:GetPivot()

	local network = self.network
	network:StartTrace(node)

	node:Alert()

end
