
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local mod = Module:NewClass
{ 
	ID = '{a515d826-4fc0-4d25-83c9-2f699dd6869b}', 
	name = "Needle", 
	use = ModuleUse.Subroutine,
	description = "Breaks the selected subroutine. Needle is Undetectable when the host node is not Alerted.",
	tokens = 1
}

-- =======================================================================

function mod:RunOnSubroutine (subroutine)
	
	self:CreateEffectOnSubroutine('needle', subroutine)

end

-- =======================================================================

mod.handlers['break'] = function (self, effect)

	local subroutine = effect:GetPivot()
	
	local host = subroutine:GetHost()
	local undetectable = (not host:IsAlerted()) or nil

	subroutine:Break(BreakContext.new({ undetectable = undetectable }))

end

