
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local mod = Module:NewClass
{ 
	ID = '{4f0bf92b-c3e2-4f1d-9d4b-6f37eacdf86e}', 
	name = "Chimaera",
	use = ModuleUse.Node,
	nodeClassesLimit = { NodeClass.Router },
	description = "Breaches the selected node. Whenenver Chimaera is used, its [T] requirement is set to how many nodes are connected to the selected node.",
	tokens = 2
}

-- =======================================================================

function mod:RunOnNode (node)

	self:CreateEffectOnNode('chimaera', node)

	local tokens = #node:GetConnectedNodes()
	self:SetRequiredTokens(tokens)

end

-- =======================================================================

mod.handlers['breach'] = function (self, effect)

	local node = effect:GetPivot()
	node:Breach(BreachContext.new({}))

end
