
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local mod = Module:NewClass
{ 
	ID = '{13aee470-8832-46e0-9e06-985ce06a540d}', 
	name = "Marble",
	use = ModuleUse.Instant,
	description = "Generates 6[T]. Generates 2[T] less on each subsequent use."
}

-- =======================================================================

function mod:Init()
	
	local values = self.values
	values['tokens'] = 6

end

-- =======================================================================

function mod:GetRuntimeDescription()

	local values = self.values
	local tokens = values['tokens']

	if tokens > 0 then

		return strFormat("Generates %d[T]. Generates 2[T] less on each subsequent use.", tokens)

	else

		return "[Depleted]"

	end
	
end

-- =======================================================================

function mod:Run()

	self:CreateEffect('marble')

end

-- =======================================================================

mod.handlers['tokens'] = function (self, effect)

	local values = self.values
	local tokens = networkScreen:GetRun():GetTokens()

	tokens:Add(values['tokens'])
	values['tokens'] = math.max(values['tokens'] - 2, 0)

end

