
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local mod = Module:NewClass
{ 
	ID = '{89575252-49e6-48c4-9a2e-89b77d68b614}', 
	name = "Split", 
	use = ModuleUse.Node,
	nodeClassesLimit = { NodeClass.Router },
	description = "Installs all the coroutines installed on the selected node on all the nodes connected to it instead.",
	traits = { ModuleTrait.Subtle },
	tokens = 3
}

-- =======================================================================

function mod:AcceptsNode (node)

	return #node:GetActiveCoroutines() > 0

end

-- =======================================================================

function mod:RunOnNode (node)
	
	self:CreateEffectOnNode('_031-_-center', node)
	for n in node:GetConnectedNodes(NodeClass.Router):Each() do
		
		self:CreateEffectOnNode('_031-_-leaves', n)

	end

end

-- =======================================================================

mod.handlers['install'] = function (self, effect)

	local node = effect:GetPivot()
	local coroutines = node:GetActiveCoroutines()

	for n in node:GetConnectedNodes(NodeClass.Router):Each() do
		for coroutine in coroutines:Each() do
		
			self:CreateCoroutine(n, coroutine:GetID())

		end
	end

	for coroutine in coroutines:ReverseEach() do
		coroutine:Remove()
	end

end

-- =======================================================================

mod.handlers[''] = function (self, effect)

end
	
