
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local mod = Module:NewClass
{ 
	ID = '{571a384b-13b6-4a5b-908e-32dcfed1dcf0}',
	name = "_032", 
	use = ModuleUse.Node,
	nodeClassesLimit = { NodeClass.Router },
	description = "Installs coroutines on all nodes connected to the selected node: Clears an Alert on the host node when a Trace reaches the host node.",
	traits = { ModuleTrait.Subtle },
	tokens = 2
}

-- =======================================================================

function mod:RunOnNode (node)

	for n in node:GetConnectedNodes(NodeClass.Router):Each() do
		
		self:CreateEffectOnNode('coroutine', n)

	end

end

-- =======================================================================

mod.handlers['install'] = function (self, effect)

	local node = effect:GetPivot()
	self:CreateCoroutine(node, '{edee8ab7-b383-44e9-aab9-97028afff43b}')

end
