
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local mod = Module:NewClass
{ 
	ID = '{3614c794-427d-4e9c-b178-4b086f5a7174}', 
	name = "_033", 
	use = ModuleUse.Subroutine,
	description = "Breaks the selected subroutine. Generates 1[T] and alerts all nodes connected to the host node.",
	traits = { ModuleTrait.Impact },
	tokens = 0
}

-- =======================================================================

function mod:RunOnSubroutine (subroutine)
	
	self:CreateEffectOnSubroutine('_033-_-subroutine', subroutine)
	for n in subroutine:GetHost():GetConnectedNodes(NodeClass.Router):Each() do
		
		self:CreateEffectOnNode('_033-_-leaves', n)

	end

end

-- =======================================================================

mod.handlers['break'] = function (self, effect)

	local subroutine = effect:GetPivot()
	subroutine:Break(BreakContext.new({ impact = true }))

end

-- =======================================================================

mod.handlers['tokens'] = function (self, effect)

	local tokens = networkScreen:GetRun():GetTokens()
	tokens:Add(2)

end

-- =======================================================================

mod.handlers['alert'] = function (self, effect)

	local node = effect:GetPivot()
	node:Alert()

end
