
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local mod = Module:NewClass
{ 
	ID = '{57c3f5cb-4616-4d99-9ec7-70e787855886}', 
	name = "Black Tulip",
	use = ModuleUse.Node,
	nodeClassesLimit = { NodeClass.Router },
	description = "Generates 1[T] per each revealed subroutine on the selected node. Alerts the node once per each such subroutine.",
	traits = { ModuleTrait.Subtle },
	tokens = 1
}

-- =======================================================================

function mod:RunOnNode (node)

	self:CreateEffectOnNode('black-tulip', node)

end

-- =======================================================================

mod.handlers['execution'] = function (self, effect)

	local node = effect:GetPivot()

	local isRevealed = function (s) return s:IsRevealed() end
	local count = #node:GetSubroutines():Select(isRevealed)

	networkScreen:GetRun():GetTokens():Add(count)
	node:Alert(count)

end
