
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local mod = Module:NewClass
{ 
	ID = '{fab10268-f24a-458f-a284-ca34fd743dcc}', 
	name = "Cassiopea",
	use = ModuleUse.Node,
	nodeClassesLimit = { NodeClass.Router },
	description = "Breaches the selected node. Alerts all the connected nodes.",
	traits = { ModuleTrait.Undetectable },
	tokens = 2
}

-- =======================================================================

function mod:RunOnNode (node)

	self:CreateEffectOnNode('cassiopea-_-center', node)
	for n in node:GetConnectedNodes(NodeClass.Router):Each() do
		
		self:CreateEffectOnNode('cassiopea-_-leaves', n)

	end

end

-- =======================================================================

mod.handlers['breach'] = function (self, effect)

	local node = effect:GetPivot()
	node:Breach(BreachContext.new({ undetectable = true }))

end

-- =======================================================================

mod.handlers['alert'] = function (self, effect)

	local node = effect:GetPivot()
	node:Alert()

end
