
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local builder = OperationBuilder:NewClass
{
	ID = 'kita-adachi:competitor-research',
	description = "(...)"
}

-- =======================================================================

function builder:CreateCoordinate()

	local details = self.details
	local rank = details['rank']

	return Coordinate.new({ index = random:IntValue(2, 5), rank = random:IntValue(3*rank-1, 3*rank+1) })

end

-- =======================================================================

-- [Base operation builder override]
function builder:Construct()

	if random:Chance(0.85) then

		self:AddTargets(OperationTargetClass.Data, random:IntValue(3, 6))

	else

		local condition = PayloadCondition:NewInstance('access-all-node-class', { class = NodeClass.Database })
		local payload = Payload.new(condition, random:IntValue(2, 4))

		self:SetPayload(payload)

	end

end

