
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local tutorial = Tutorial:NewClass
{
	ID = '_001',
	rootDir = '_001',
	name = "Introduction",
}

-- =======================================================================

function tutorial:Init()

	networkScreen:GetNetworkControl():GetCameraControl():SetPos(300, 72.5)

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.Breach] = function (self, context)

	local node = context['node']
	if node:GetID() == 2 then

		self:ShowHint('breach-2')
		return

	end

	local network = networkScreen:GetNetwork()

	local nodeA = network:GetNodeWithID(3)
	local nodeB = network:GetNodeWithID(5)

	if (node == nodeA and nodeB:BlocksAccess()) or (node == nodeB and nodeA:BlocksAccess()) then

		self:ShowHint('terminal')
		return

	end

	if network:GetNodes(NodeClass.Terminal):First(function (n) return not n:IsAccessed() end) == nil then

		self:Finish()
		return
	
	end

end
