
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local tutorial = Tutorial:NewClass
{
	ID = '_002',
	rootDir = '_002',
	name = "Perimeter, Gateway, Database",
}

-- =======================================================================

function tutorial:Init()

	networkScreen:GetNetworkControl():GetCameraControl():SetPos(450, 72.5)

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.Breach] = function (self, context)

	local node = context['node']
	if node:GetID() == 2 then

		self:ShowHint('perimeter')
		return

	end

	if node:GetID() == 3 then

		self:ShowHint('advance')
		return

	end

	local network = networkScreen:GetNetwork()

	local nodeA = network:GetNodeWithID(4)
	local nodeB = network:GetNodeWithID(6)

	if (node == nodeA and nodeB:BlocksAccess()) or (node == nodeB and nodeA:BlocksAccess()) then

		self:ShowHint('gateway')
		return

	end

	if node:GetID() == 5 and (not node:BlocksAccess()) then

		self:ShowHint('database')
		return

	end

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.PerimeterReduction] = function (self, context)

	local node = context['node']
	if node:GetID() == 3 then

		self:ShowAlternativeHint('module-shortcuts')
		return

	end

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.ModuleExecutionViaShortcut] = function (self, context)

	if self:ShowsAlternativeHint() and self:GetShownAlternativeHint():GetID() == 'module-shortcuts' then

		self:ClearAlternativeHint()

	end

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.DataDownload] = function (self, context)

	local network = networkScreen:GetNetwork()
	local node = network:GetNodeWithID(9)

	local isNotDownloaded = function (data) return data:GetState() ~= DataState.Downloaded end
	if not node:GetData():First(isNotDownloaded) then

		self:Finish()

	end

end
