-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local tutorial = Tutorial:NewClass
{
	ID = '_003',
	rootDir = '_003',
	name = "Subroutine, Trace, Alert",
}

-- =======================================================================

function tutorial:Init()

	networkScreen:GetNetworkControl():GetCameraControl():SetPos(450, 72.5)

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.Breach] = function (self, context)

	local node = context['node']
	if node:GetID() == 2 then

		self:ShowHint('subroutines-reactive')
		self:ShowAlternativeHint('viewport')

		return

	end

	if node:GetID() == 3 then

		self:ShowHint('breakers')
		self:AddModule('{577bd6d4-aaef-4d75-98b5-f4d64d56c5ec}')

		return

	end

	if node:GetID() == 6 then

		self:ShowHint('trace-introduction')
		return

	end

	local network = networkScreen:GetNetwork()

	local nodeA = network:GetNodeWithID(11)
	local nodeB = network:GetNodeWithID(13)

	if (node == nodeA and nodeB:BlocksAccess()) or (node == nodeB and nodeA:BlocksAccess()) then

		self:ShowHint('stealth-1')
		return

	end

	if node:GetID() == 12 then

		self:ShowHint('reveal-1')
		self:AddModule('{73750128-630e-4b3e-a865-9b2147ef5214}')
		return

	end

	local isNotAccessed = function (n) return not n:IsAccessed() end
	if #network:GetNodes():Select(isNotAccessed) == 0 then

		self:Finish()
		return

	end

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.ViewportMove] = function (self, context)

	if self:ShowsAlternativeHint() and self:GetShownAlternativeHint():GetID() == 'viewport' then

		self:ClearAlternativeHint()

	end

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.Break] = function (self, context)

	if self:GetShownHint():GetID() == 'breakers' then

		self:ShowHint('explore')

	end

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.Trace] = function (self, context)

	if self:GetShownHint():GetID() == 'trace-start' then

		self:ShowHint('trace-explanation')

	end

end
