-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local tutorial = Tutorial:NewClass
{
	ID = '_004',
	rootDir = '_004',
	name = "Subtle, Undetectable, Impact",
}

-- =======================================================================

function tutorial:Init()

	networkScreen:GetNetworkControl():GetCameraControl():SetPos(450, 72.5)

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.SubroutineReveal] = function (self, context)

	local subroutine = context['subroutine']
	if subroutine:GetHost():GetID() == 2 then

		self:ShowHint('prevent-breach-1')
		return

	end

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.Breach] = function (self, context)

	local node = context['node']
	if node:GetID() == 2 then

		self:ShowHint('impact-1')
		return

	end

	if node:GetID() == 3 then

		self:ShowHint('undetectable-1')
		return

	end

	local network = networkScreen:GetNetwork()

	local nodeA = network:GetNodeWithID(4)
	local nodeB = network:GetNodeWithID(5)

	if (node == nodeA or node == nodeB) and (not nodeA:BlocksAccess()) and (not nodeB:BlocksAccess())  then

		self:ShowHint('undetectable-6')
		return

	end

	if node:GetID() == 8 then

		self:ShowHint('breaker-1')
		return

	end

	local nodeA = network:GetNodeWithID(9)
	local nodeB = network:GetNodeWithID(10)

	if (node == nodeA or node == nodeB) and (not nodeA:BlocksAccess()) and (not nodeB:BlocksAccess())  then

		self:ShowHint('subtle-1')
		return

	end

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.HintShow] = function (self, context)

	local ID = context['ID']
	if ID == 'prevent-breach-2' then

		self:AddModule('{577bd6d4-aaef-4d75-98b5-f4d64d56c5ec}')
		return

	end

	if ID == 'impact-3' then

		self:AddModule('{9c54e5c4-26d3-418c-ae3c-8b927ec14b70}')
		return

	end

	if ID == 'undetectable-4' then

		self:AddModule('{fab10268-f24a-458f-a284-ca34fd743dcc}')
		return

	end

	if ID == 'breaker-2' then

		self:AddModule('{6e8ad689-8ae7-48cc-b972-0b4cf5bf9bf2}')
		return

	end

	if ID == 'subtle-2' then

		self:AddModule('{597f7d8e-948d-45b6-9844-2a433ec3e8eb}')
		return

	end

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.ModuleExecution] = function (self, context)

	local module = context['module']
	if module:GetID() == '{597f7d8e-948d-45b6-9844-2a433ec3e8eb}' then

		self:Finish()
		return

	end

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.Trace] = function (self, context)

	self:ShowAlternativeHint('trace')

end
