
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

DevConsoleLine = {}
DevConsoleLine.__index = DevConsoleLine

-- =======================================================================

function DevConsoleLine.new (console, kind, text)

	local new = {}
	setmetatable(new, DevConsoleLine)
	
	new.console = console
	new.kind = kind
	new.text = text or ''

	return new

end

-- =======================================================================

function DevConsoleLine:Draw (screenX, screenY)

	local paddX = 4
	local paddY = 2

	self.kind.color:SetAsLoveColor()
	love.graphics.setFont(self.console:GetFont())

	local text = (self.prefix or '') .. self.text
	love.graphics.print(text, screenX+paddX, screenY+paddY)

end

-- =======================================================================

function DevConsoleLine:SetPrefix (prefix)

	self.prefix = prefix

end

-- =======================================================================

function DevConsoleLine:SetText (text)

	self.text = text

end

-- =======================================================================

function DevConsoleLine:GetText()

	return self.text

end

-- =======================================================================

function DevConsoleLine:GetKind()

	return self.kind

end

