
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

OutputFile = {}
OutputFile.__index = OutputFile

-- =======================================================================

function OutputFile.new (path)

	local new = {}
	setmetatable(new, OutputFile)

	new:Init(path, 'w')

	return new

end

-- =======================================================================

function OutputFile.newForAppend (path)

	local new = {}
	setmetatable(new, OutputFile)

	new:Init(path, 'a')

	return new

end

-- =======================================================================

function OutputFile:Init (path, mode)

	self.loveFile = love.filesystem.newFile(path)
	assert(self.loveFile:open(mode), strFormat("Failed to open '%s'.", path))	

end

-- =======================================================================

function OutputFile:Write (str)

	self.loveFile:write(str)

end

-- =======================================================================

function OutputFile:WriteLine (str)

	self:Write((str or '') .. '\n')

end

-- =======================================================================

function OutputFile:Close()
	
	self.loveFile:close()

end

