
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Random = {}
Random.__index = Random

-- =======================================================================

function Random.new()

	local new = {}
	setmetatable(new, Random)
	
	new.randomGenerator = love.math.newRandomGenerator(os.time())
	new:ReceiveImpulse(os.time())

	return new

end

-- GENERATION ============================================================
-- =======================================================================

function Random:IntValue (min, max)

	return self.randomGenerator:random(min, max)

end

-- =======================================================================

function Random:Value (min, max)
	
	return self:ZeroToOne()*(max-min) + min

end

-- =======================================================================

function Random:ZeroToOne()

	return self.randomGenerator:random()

end

-- =======================================================================

function Random:Chance (chance)
	
	if chance >= 1 then
		return true
	end

	return self:ZeroToOne() < chance

end

-- IMPULSE ===============================================================
-- =======================================================================

function Random:ReceiveImpulse (impulse)
	
	for n = 1, impulse % 4 do
		self:Value(0, impulse)
	end

end

