
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Achievement = Entity.new()
Achievement.__index = Achievement

-- =======================================================================

function Achievement:__class_setup__ (params)

	self.ID = params.ID
	self.class = params.class
	self.description = params.description
	self.values = Values.new(params.values)
	
	self.reactions = Map.new()

end

-- =======================================================================

function Achievement:new()

	local new = {}
	setmetatable(new, self)

	return new

end

-- COMPLETION ============================================================
-- =======================================================================

function Achievement:Complete()
	
	self:MarkAsComplete()

	local ps = PersistenceSaver.new()
	ps:Save(consts.persistenceFilePath)

end

-- =======================================================================

function Achievement:MarkAsComplete()

	self.complete = true

end

-- =======================================================================

function Achievement:IsComplete()
	
	return self.complete ~= nil

end

-- REACTIONS =============================================================
-- =======================================================================

function Achievement:React (impulse, context)

	local reaction = self.reactions[impulse]
	if reaction then

		reaction(self, context)

	end

end

-- DESCRIPTION ===========================================================
-- =======================================================================

-- [Achievement classes can override this]
function Achievement:GetDescription()
	
	return self.description

end

-- EXPOSE ================================================================
-- =======================================================================

function Achievement:GetID()
	
	return self.ID

end

-- =======================================================================

function Achievement:GetClass()
	
	return self.class

end

