
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Assets = {}
Assets.__index = Assets

-- =======================================================================

function Assets.new()

	local new = {}
	setmetatable(new, Assets)
	
	new.chips = Collection.new()
	new.consoles = Collection.new()
	new.coordinates = Collection.new()
	new.data = Collection.new()
	new.kernels = Collection.new()
	new.modules = Collection.new()

	return new

end

-- CHIPS =================================================================
-- =======================================================================

function Assets:AddChip (chip)
	
	self.chips:Add(chip)

end

-- =======================================================================

function Assets:GetChips()
	
	return self.chips

end

-- CONSOLES ==============================================================
-- =======================================================================

function Assets:AddConsole (console)
	
	self.consoles:Add(console)

end

-- =======================================================================

function Assets:GetConsoles()
	
	return self.consoles

end

-- COORDINATES ===========================================================
-- =======================================================================

function Assets:AddCoordinate (coordinate)
	
	self.coordinates:Add(coordinate)

end

-- =======================================================================

function Assets:GetCoordinates()

	self:PruneExpiredCoordinates()
	return self.coordinates

end

-- =======================================================================

function Assets:PruneExpiredCoordinates()
	
	local isExpired = function (coordinate) return coordinate:IsExpired() end
	self.coordinates:RemoveWithPredicate(isExpired)

end

-- DATA ==================================================================
-- =======================================================================

function Assets:AddData (data)
	
	self.data:Add(data)

end

-- =======================================================================

function Assets:GetData()
	
	return self.data

end

-- KERNELS ===============================================================
-- =======================================================================

function Assets:AddKernel (kernel)
	
	self.kernels:Add(kernel)

end

-- =======================================================================

function Assets:GetKernels()
	
	return self.kernels

end

-- MODULES ===============================================================
-- =======================================================================

function Assets:AddModule (module)
	
	self.modules:Add(module)

end

-- =======================================================================

function Assets:GetModules()
	
	return self.modules

end


