
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Backstory = Entity.new()
Backstory.__index = Backstory

-- =======================================================================

function Backstory:__class_setup__ (params)

	self.name = params.name
	self.description = params.description
	self.comment = params.comment
	self.achievement = params.achievement
	self.karma = params.karma
	self.values = Values.new(params.values)

end

-- =======================================================================

function Backstory:new()

	local new = {}
	setmetatable(new, self)

	return new

end

-- UNLOCK ================================================================
-- =======================================================================

function Backstory:RequiresAchievement()
	
	return self.achievement ~= nil

end

-- =======================================================================

function Backstory:GetAchievement()
	
	return self.achievement

end

-- =======================================================================

function Backstory:IsUnlocked()

	if self.achievement == nil then
		return true
	end

	local achievement = achievements:GetAchievement(self.achievement)
	return achievement:IsComplete()

end

-- DESCRIPTION ===========================================================
-- =======================================================================

-- [Backstory classes can override this]
function Backstory:GetDescription()
	
	return self.description

end

-- EXPOSE ================================================================
-- =======================================================================

function Backstory:GetName()
	
	return self.name

end

-- =======================================================================

function Backstory:GetComment()
	
	return self.comment

end

-- =======================================================================

function Backstory:GetKarma()
	
	return self.karma

end

