
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

CharacterBuilder = Entity.new()
CharacterBuilder.__index = CharacterBuilder

-- =======================================================================

function CharacterBuilder:__class_setup__ (params)

	self.role = params.role
	self.affiliation = params.affiliation

end

-- =======================================================================

function CharacterBuilder:new (details)

	local new = {}
	setmetatable(new, self)
	
	new.details = Values.new(details)

	return new

end

-- =======================================================================

function CharacterBuilder:Build()

	local character = Character.new(names:GetRandom())

	if self.role then

		local role = roles:Get(self.role)
		character:SetRole(role)

	end
	
	if self.affiliation then

		local affiliation = organisations:Get(self.affiliation)
		character:SetAffiliation(affiliation)

	end

	self.character = character
	self:Construct()
	
	return character

end

-- =======================================================================

-- [Character template classes can override this]
function CharacterBuilder:Construct()
	
	error(strFormat("Character builder with ID '%s' doesn't implement the required Construct() method.", self.ID))

end

