
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Characters = {}
Characters.__index = Characters

-- =======================================================================

function Characters.new()

	local new = {}
	setmetatable(new, Characters)
	
	new.characters = Collection.new()

	return new

end

-- =======================================================================

function Characters:AddCharacter (character)
	
	self.characters:Add(character)

end

-- =======================================================================

function Characters:RemoveCharacter (character)
	
	self.characters:RemoveValue(character)

end

-- ... ===================================================================
-- =======================================================================

function Characters:AddCharacterFromBuilder (ID, details)
	
	local builder = CharacterBuilder:NewInstance(ID, details)
	local character = builder:Build()

	self:AddCharacter(character)
	return character

end

-- GAME TIME =============================================================
-- =======================================================================

function Characters:ReceiveTick()

	for character in self.characters:Each() do
		character:ReceiveTick()
	end

end

-- EXPOSE ================================================================
-- =======================================================================

function Characters:GetCharacters()
	
	return self.characters

end

