
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Clause = {}
Clause.__index = Clause

-- =======================================================================

function Clause.new (xmlRoot)

	local new = {}
	setmetatable(new, Clause)
	
	new:LoadFromXML(xmlRoot)

	return new

end

-- =======================================================================

function Clause:LoadFromXML (xmlRoot)
	
	self.text = Text.new(xmlRoot:GetCleanContent())

	local kind = xmlRoot:GetAttribute('kind') or 'general'
	self.kind = ClauseKind:FromStr(kind)

end

-- EXPOSE ================================================================
-- =======================================================================

function Clause:GetText()
	
	return self.text

end

-- =======================================================================

function Clause:GetKind()

	return self.kind

end

