
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Console = {}
Console.__index = Console

-- =======================================================================

function Console.new (xmlRoot)

	local new = {}
	setmetatable(new, Console)
	
	new:LoadFromXML(xmlRoot)

	return new

end

-- =======================================================================

function Console:LoadFromXML (xmlRoot)

	self.ID = assert(xmlRoot:GetAttribute('ID'), "Invalid console ID.")
	self.name = assert(xmlRoot:GetAttribute('name'), strFormat("Console with ID '%s' declared without a name.", self.ID))

	self.modules = assert(xmlRoot:GetAttribute('modules'), strFormat("Console with ID '%s' declared without module slot count.", self.ID))
	self.chips = assert(xmlRoot:GetAttribute('chips'), strFormat("Console with ID '%s' declared without chip slot count.", self.ID))


end

-- EXPOSE ================================================================
-- =======================================================================

function Console:GetID()

	return self.ID

end

-- =======================================================================

function Console:GetName()

	return self.name

end

-- =======================================================================

function Console:GetModuleSlots()
	
	return self.modules

end

-- =======================================================================

function Console:GetChipSlots()
	
	return self.chips

end

