
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Coordinate = {}
Coordinate.__index = Coordinate

-- =======================================================================

function Coordinate.new (params)

	local new = {}
	setmetatable(new, Coordinate)

	new.params = params
	new.networkBuilder = NetworkBuilder.new(new)

	return new

end

-- NAME ==================================================================
-- =======================================================================

function Coordinate:GetNetworkName()

	return self.networkBuilder:GetNetworkName()

end
	
-- EXPIRATION ============================================================
-- =======================================================================

function Coordinate:Expire()

	self.expired = true

end

-- =======================================================================

function Coordinate:IsExpired()

	return self.expired ~= nil

end

-- EXPOSE ================================================================
-- =======================================================================

function Coordinate:GetOrganisation()
	
	return self.params['organisation']

end

-- =======================================================================

function Coordinate:GetIndex()
	
	return self.params['index']

end

-- =======================================================================

function Coordinate:GetRank()
	
	return self.params['rank']

end

-- =======================================================================

function Coordinate:GetRankText()
	
	-- ===
	-- TEMP
	-- ===

	local rank = self:GetRank()
	local texts = Collection.new
	{ 
		{ min = 0, text = "Poor" },
		{ min = 2, text = "Crude" },
		{ min = 4, text = "Sub-standard" },
		{ min = 4, text = "Standard" },
		{ min = 6, text = "Considerable" },
		{ min = 8, text = "Remarkable" }
	}

	return texts:Last(function (it) return it.min <= rank end).text

end

