
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Credits = {}
Credits.__index = Credits

-- =======================================================================

function Credits.new (balance)

	local new = {}
	setmetatable(new, Credits)
	
	new.balance = balance

	return new

end

-- =======================================================================

function Credits:Add (amount)
	
	self:SetBalance(self.balance + amount)

end

-- =======================================================================

function Credits:CanSpend (amount)
	
	return self.balance >= amount

end

-- =======================================================================

function Credits:Spend (amount)
	
	self:SetBalance(self.balance - amount)

end

-- =======================================================================

function Credits:SetBalance (balance)

	self.balance = balance
	
	achievements:ReceiveImpulse(AchievementImpulse.Credits, {})

end

-- =======================================================================

function Credits:GetBalance()
	
	return self.balance

end

