
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

DataLabel = {}
DataLabel.__index = DataLabel

-- =======================================================================

function DataLabel.new (xmlRoot)

	local new = {}
	setmetatable(new, DataLabel)
	
	new:LoadFromXML(xmlRoot)
	
	return new

end

-- =======================================================================

function DataLabel:LoadFromXML (xmlRoot)

	self.ID = assert(xmlRoot:GetAttribute('ID'), "A data label doesn't have its 'ID' attribute declared.")
	self.label = assert(xmlRoot:GetAttribute('label'), strFormat("A data label with ID '%s' doesn't have its 'label' attribute declared.", self.ID))

end

-- EXPOSE ================================================================
-- =======================================================================

function DataLabel:GetID()

	return self.ID

end

-- =======================================================================

function DataLabel:GetLabel()

	return self.label

end

