
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Download = {}
Download.__index = Download

-- =======================================================================

function Download.new (data)

	local new = {}
	setmetatable(new, Download)
	
	new.data = data
	new.download = 0

	return new

end

-- =======================================================================

function Download:ReceiveDownloadPoints (points)
	
	self.download = math.min(self.download + points, self.data:GetSize())

end

-- =======================================================================

function Download:Interrupt()
	
end

-- =======================================================================

function Download:Pause()
	
	self.pause = true

end

-- =======================================================================

function Download:Resume()
	
	self.pause = nil

end

-- EXPOSE ================================================================
-- =======================================================================

function Download:GetDownload()
	
	return self.download

end

-- =======================================================================

function Download:IsComplete()
	
	return self.download == self.data:GetSize()

end

-- =======================================================================

function Download:IsPaused()
	
	return self.pause ~= nil

end
