
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Downloads = {}
Downloads.__index = Downloads

-- =======================================================================

function Downloads.new (network)

	local new = {}
	setmetatable(new, Downloads)
	
	new.network = network

	return new

end

-- =======================================================================

function Downloads:ReceiveTimePulse (pulse)
	
	local speed = 512
	local points = speed * deck:GetDownloadSpeedMod() * pulse

	local downloads = Collection.new()
	for node in self.network:GetNodes(NodeClass.Database):Each() do

		for data in node:GetData():Each() do

			if data:GetState() == DataState.Download and (not data:GetDownload():IsPaused()) then
				downloads:Add(data)
			end

		end

	end

	for data in downloads:Each() do
		data:ReceiveDownloadPoints(points / #downloads)
	end

end

