
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Evasion = Entity.new()
Evasion.__index = Evasion

-- =======================================================================

function Evasion:__class_setup__ (params)

	self.active = params.active
	self.description = params.description

	self.reactions = Map.new()

end

-- =======================================================================

function Evasion:new (values)

	local new = {}
	setmetatable(new, self)

	new.values = Values.new(values)

	return new

end

-- EVASION ===============================================================
-- =======================================================================

function Evasion:Evade()

	local network = self.tracker:GetNetwork()
	network:StopTracker(self.tracker)

end

-- =======================================================================

function Evasion:ExecuteEvade()

	self:Execute()
	self:Evade()

end

-- REACTIONS =============================================================
-- =======================================================================

function Evasion:React (impulse)

	local reaction = self.reactions[impulse]
	if reaction then

		reaction(self)

	end

end

-- DESCRIPTION ===========================================================
-- =======================================================================

-- [Evasion classes can override this]
function Evasion:GetDescription()

	return assert(self.description, strFormat("Evasion with ID '%s' neither has a static description nor overrides the 'GetDescription()' method.", self.ID))

end

-- EXPOSE ================================================================
-- =======================================================================

function Evasion:IsActive()
	
	return self.active ~= nil

end

