
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

EventChoice = {}
EventChoice.__index = EventChoice

-- =======================================================================

function EventChoice.new (event, ID)

	local new = {}
	setmetatable(new, EventChoice)
	
	new.event = event
	new.ID = ID

	return new

end

-- INVOKATIONS ===========================================================
-- =======================================================================

function EventChoice:GetCost (event)

	if self.cost == nil then
		return nil
	end

	return self.cost(event)

end

-- =======================================================================

function EventChoice:Execute (event)
	
	if self.execute == nil then
		return
	end

	self.execute(event)

end

-- =======================================================================

function EventChoice:GetResponseValues (event)
	
	if self.responseValues == nil then
		return
	end

	return self.responseValues(event)

end

-- EXPOSE ================================================================
-- =======================================================================

function EventChoice:GetID()
	
	return self.ID

end

-- =======================================================================

function EventChoice:GetCaption()

	self.caption = self.caption or eventTexts:GetChoiceCaption(self.event:GetID(), self.ID)
	return self.caption

end

-- =======================================================================

function EventChoice:GetResponse()

	self.response = self.response or eventTexts:GetChoiceResponse(self.event:GetID(), self.ID)
	return self.response
	
end

