
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

EventExposure = {}
EventExposure.__index = EventExposure

-- =======================================================================

function EventExposure.new()

	local new = {}
	setmetatable(new, EventExposure)
	
	return new

end

-- CONSTRUCTION ==========================================================
-- =======================================================================

function EventExposure:SetTitle (title)
	
	self.title = title

end

-- =======================================================================

function EventExposure:SetNarrative (narrative)
	
	self.narrative = narrative

end

-- =======================================================================

function EventExposure:AddOption (option)
	
	self.options = self.options or Collection.new()
	self.options:Add(option)

end

-- EXPOSE ================================================================
-- =======================================================================

function EventExposure:GetTitle()

	return self.title

end

-- =======================================================================

function EventExposure:GetNarrative()

	return self.narrative

end

-- =======================================================================

function EventExposure:HasOptions()

	return self.options ~= nil

end

-- =======================================================================

function EventExposure:GetOptions()

	return self.options

end

