
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Explanation = {}
Explanation.__index = Explanation

-- =======================================================================

function Explanation.new (ID)

	local new = {}
	setmetatable(new, Explanation)
	
	new.ID = ID
	new:InitText()

	return new

end

-- =======================================================================

function Explanation:InitText()
	
	self.text = explanationTexts:GetText(self.ID)

end

-- ... ===================================================================
-- =======================================================================

function Explanation:Suppress()

	self.suppressed = true

end

-- =======================================================================

function Explanation:IsSuppressed()
	
	return self.suppressed ~= nil

end

-- ... ===================================================================
-- =======================================================================

function Explanation:GetID()
	
	return self.ID

end

-- =======================================================================

function Explanation:GetTitle()
	
	return self.text:GetTitle()

end

-- =======================================================================

function Explanation:GetLines()
	
	return self.text:GetLines()

end

-- =======================================================================

function Explanation:GetWidth()
	
	return self.text:GetWidth()

end

