
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

ExplanationText = {}
ExplanationText.__index = ExplanationText

-- =======================================================================

function ExplanationText.new (xmlRoot)

	local new = {}
	setmetatable(new, ExplanationText)

	new:LoadFromXML(xmlRoot)
	
	return new

end

-- =======================================================================

function ExplanationText:LoadFromXML (xmlRoot)
	
	self.title = xmlRoot:GetRequiredAttribute('title')
	self.width = xmlRoot:GetRequiredAttribute('width')

	self.lines = Collection.new()
	for _, lineElement in xmlRoot:EachElement('line') do

		local line = lineElement:GetCleanContent():gsub('|', '\n')
		self.lines:Add(line)

	end

end

-- =======================================================================

function ExplanationText:GetTitle()
	
	return self.title

end

-- =======================================================================

function ExplanationText:GetLines()
	
	return self.lines

end

-- =======================================================================

function ExplanationText:GetWidth()
	
	return self.width

end
