
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

ExplanationTexts = {}
ExplanationTexts.__index = ExplanationTexts

-- =======================================================================

function ExplanationTexts.new()

	local new = {}
	setmetatable(new, ExplanationTexts)
	
	new.texts = Map.new()
	new:LoadFromXML('data/explanations.xml')

	return new

end

-- =======================================================================

function ExplanationTexts:LoadFromXML (sourceFilePath)
	
	local xmlRoot = XmlDocument.newFromFile(sourceFilePath):GetRoot()
	for _, explanationElement in xmlRoot:EachElement() do

		local ID = explanationElement:GetRequiredAttribute('ID')
		assert(not self.texts:ContainsKey(ID), strFormat("Duplicate explanation ID '%s'.", ID))

		local explanationText = ExplanationText.new(explanationElement)
		self.texts[ID] = explanationText

	end

end

-- =======================================================================

function ExplanationTexts:GetText (ID)
	
	return assert(self.texts[ID], strFormat("No explanation with ID '%s' has texts loaded.", ID))

end

