
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Explanations = {}
Explanations.__index = Explanations

-- =======================================================================

function Explanations.new()

	local new = {}
	setmetatable(new, Explanations)
	
	new.explanations = Map.new()
	new:Init()

	return new

end

-- INIT ==================================================================
-- =======================================================================

function Explanations:Init()
	
	self:InitExplanation('aspirations')
	self:InitExplanation('backstories')
	self:InitExplanation('characters')
	self:InitExplanation('coordinates')
	self:InitExplanation('deck')
	self:InitExplanation('network')
	self:InitExplanation('operations')
	self:InitExplanation('payload')

end

-- =======================================================================

function Explanations:InitExplanation (ID)
	
	local explanation = Explanation.new(ID)
	self.explanations[ID] = explanation

end

-- EXPOSE ================================================================
-- =======================================================================

function Explanations:GetExplanations()
	
	return self.explanations

end

-- =======================================================================

function Explanations:GetExplanation (ID)
	
	return assert(self.explanations[ID], strFormat("There is no explanation with ID '%s'.", ID))

end

