
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Name = {}
Name.__index = Name

-- =======================================================================

function Name.new (xmlRoot)

	local new = {}
	setmetatable(new, Name)

	new:LoadFromXML(xmlRoot)
	
	return new

end

-- =======================================================================

function Name:LoadFromXML (xmlRoot)
	
	self.nominative = assert(xmlRoot:GetAttribute('nominative'), "A name doesn't have the 'name' attribute declared.")
	self.sex = Sex:FromStr(assert(xmlRoot:GetAttribute('sex'), strFormat("The '%s' name doesn't have its 'sex' attribute declared.", self.nominative)))

end

-- =======================================================================

function Name:GetNominative()

	return self.nominative

end

-- =======================================================================

function Name:GetSex()
	
	return self.sex

end

-- =======================================================================

function Name:GetPronoun()

	return self.sex.pronoun

end

-- =======================================================================

function Name:GetToniquePronoun()

	return self.sex.tonique

end

-- =======================================================================

function Name:GetPossessivePronoun()

	return self.sex.possessive

end

