
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Names = {}
Names.__index = Names

-- =======================================================================

function Names.new (sourceFilePath)

	local new = {}
	setmetatable(new, Names)
	
	new.names = Collection.new()
	new:LoadFromFile(sourceFilePath)

	return new

end

-- =======================================================================

function Names:LoadFromFile (sourceFilePath)
	
	local xmlRoot = XmlDocument.newFromFile(sourceFilePath):GetRoot()
	for _, nameElement in xmlRoot:EachElement() do

		local name = Name.new(nameElement)
		self.names:Add(name)

	end

end

-- =======================================================================

function Names:GetRandom()
	
	return self.names:Random()

end

