
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz
	
NetPlanData = {}
NetPlanData.__index = NetPlanData

-- =======================================================================

function NetPlanData.new()

	local new = {}
	setmetatable(new, NetPlanData)
	
	new.labels = Collection.new()

	return new

end

-- XML ===================================================================
-- =======================================================================

function NetPlanData.newFromXML (xmlRoot)

	local new = NetPlanData.new()

	new.mark = xmlRoot:GetRequiredAttribute('mark')
	new.size = xmlRoot:GetRequiredAttribute('size')
	
	local labels = xmlRoot:GetRequiredAttribute('labels'):explode(',')
	for _, label in ipairs(labels) do

		local l = dataLabelEntities:Get(label)
		new.labels:Add(l)

	end

	return new

end

-- EXPOSE ================================================================
-- =======================================================================

function NetPlanData:GetMark()

	return self.mark

end

-- =======================================================================

function NetPlanData:GetSize()

	return self.size

end

-- =======================================================================

function NetPlanData:GetLabels()

	return self.labels

end

