
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz
	
NetPlanDatabase = {}
NetPlanDatabase.__index = NetPlanDatabase

-- =======================================================================

setmetatable(NetPlanDatabase, NetPlanNode)

-- =======================================================================

function NetPlanDatabase.new()

	local new = NetPlanNode.new()
	setmetatable(new, NetPlanDatabase)

	new.data = Collection.new()

	return new

end

-- XML ===================================================================
-- =======================================================================

function NetPlanDatabase.newFromXML (xmlRoot)

	local new = NetPlanDatabase.new()
	new:LoadBaseNodeDataFromXML(xmlRoot)

	-- Mark space
	new.markSpace = xmlRoot:GetRequiredAttribute('markSpace')
	
	-- Data
	for _, dataElement in xmlRoot:EachElement('data') do

		local data = NetPlanData.newFromXML(dataElement)
		new.data:Add(data)

	end

	return new

end

-- EXPOSE ================================================================
-- =======================================================================

function NetPlanDatabase:GetMarkSpace()
	
	return self.markSpace

end

-- =======================================================================

function NetPlanDatabase:GetDataPlans()
	
	return self.data

end

