
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz
	
NetPlanNode = {}
NetPlanNode.__index = NetPlanNode

-- =======================================================================

function NetPlanNode.new()

	local new = {}
	setmetatable(new, NetPlanNode)
	
	return new

end

-- XML ===================================================================
-- =======================================================================

function NetPlanNode.newFromXML (xmlRoot)
	
	local new = NetPlanNode.new()
	new:LoadBaseNodeDataFromXML(xmlRoot)

	return new

end

-- =======================================================================

function NetPlanNode:LoadBaseNodeDataFromXML (xmlRoot)

	self.ID = xmlRoot:GetRequiredAttribute('ID')
	self.class = NodeClass:FromStr(xmlRoot:GetRequiredAttribute('class'))

	self.posX = xmlRoot:GetRequiredAttribute('posX')
	self.posY = xmlRoot:GetRequiredAttribute('posY')

end

-- EXPOSE ================================================================
-- =======================================================================

function NetPlanNode:GetID()
	
	return self.ID

end

-- =======================================================================

function NetPlanNode:GetPosX()
	
	return self.posX

end

-- =======================================================================

function NetPlanNode:GetPosY()
	
	return self.posY

end

-- =======================================================================

function NetPlanNode:GetClass()
	
	return self.class

end

