
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Obstacle = {}
Obstacle.__index = Obstacle

-- =======================================================================

setmetatable(Obstacle, Node)

-- =======================================================================

function Obstacle.new (plan)

	local new = Node.new(plan)
	setmetatable(new, Obstacle)
	
	new.obstacle = true
	new.blockAccess = true
	
	return new

end

-- ACCESS ================================================================
-- =======================================================================

function Obstacle:AllowAccess()

	self.blockAccess = nil
	self.network:ExtendAccess(self)
	self.network:ExtendVision(self)

end

-- =======================================================================

function Obstacle:BlocksAccess()

	return self.blockAccess

end

-- VISION ================================================================
-- =======================================================================

-- [Node classes can override this]
function Obstacle:StartsAsVisionBlock()

	return false

end

-- =======================================================================

function Obstacle:BlockVision()

	self.blockVision = true

end

-- =======================================================================

function Obstacle:AllowVision()

	self.blockVision = nil
	self.network:ExtendVision(self)

end

-- =======================================================================

function Obstacle:BlocksVision()
	
	return self.blockVision

end
