
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

OperationTarget = {}
OperationTarget.__index = OperationTarget

-- =======================================================================

function OperationTarget.new (class)

	local new = {}
	setmetatable(new, OperationTarget)
	
	new.class = class

	return new

end

-- BINDS =================================================================
-- =======================================================================

function OperationTarget:BindData (data)
	
	assert(self.class == OperationTargetClass.Data)
	
	self.data = data
	data:BindTarget(self)

end

-- =======================================================================

function OperationTarget:GetData()
	
	assert(self.class == OperationTargetClass.Data)
	return self.data

end

-- =======================================================================

function OperationTarget:BindCoordinate (coordinate)
	
	assert(self.class == OperationTargetClass.Coordinate)
	self.coordinate = coordinate

end

-- =======================================================================

function OperationTarget:GetCoordinate()
	
	assert(self.class == OperationTargetClass.Coordinate)
	return self.coordinate

end

-- EXPOSE ================================================================
-- =======================================================================

function OperationTarget:GetClass()
	
	return self.class

end

