
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Organisation = {}
Organisation.__index = Organisation

-- =======================================================================

function Organisation.new (xmlRoot)

	local new = {}
	setmetatable(new, Organisation)
	
	new:LoadFromXML(xmlRoot)
	
	return new

end

-- =======================================================================

function Organisation:LoadFromXML (xmlRoot)

	self.ID = assert(xmlRoot:GetAttribute('ID'), "An organisation doesn't have its 'ID' attribute declared.")
	self.name = assert(xmlRoot:GetAttribute('name'), strFormat("An organisation with ID '%s' doesn't have its 'name' attribute declared.", self.ID))

end

-- EXPOSE ================================================================
-- =======================================================================

function Organisation:GetID()

	return self.ID

end

-- =======================================================================

function Organisation:GetName()

	return self.name

end

