
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Relationship = {}
Relationship.__index = Relationship

-- =======================================================================

function Relationship.new()

	local new = {}
	setmetatable(new, Relationship)
	
	new.value = random:IntValue(5, 15)

	return new

end

-- ... ===================================================================
-- =======================================================================

function Relationship:Improve (increment)

	local mod = pick(state['irresistible'] == true, 1.15, 1)
	self.value = self.value + increment * mod

	achievements:ReceiveImpulse(AchievementImpulse.RelationshipImprovement, {})

end

-- =======================================================================

function Relationship:Deteriorate (reduction)

	local mod = pick(state['irresistible'] == true, 0.9, 1)
	self.value = self.value - reduction * mod

end

-- STATUS ================================================================
-- =======================================================================

function Relationship:GetStatus()
	
	return relationshipStatuses:GetStatusForValue(self.value)

end

-- EXPOSE ================================================================
-- =======================================================================

function Relationship:GetValue()

	return self.value

end

