
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

RelationshipStatus = {}
RelationshipStatus.__index = RelationshipStatus

-- =======================================================================

function RelationshipStatus.new (xmlRoot, index)

	local new = {}
	setmetatable(new, RelationshipStatus)
	
	new.index = index
	new:LoadFromXML(xmlRoot)

	return new

end

-- =======================================================================

function RelationshipStatus:LoadFromXML (xmlRoot)

	self.ID = xmlRoot:GetRequiredAttribute('ID')
	self.text = xmlRoot:GetRequiredAttribute('text')
	self.threshold = xmlRoot:GetAttribute('threshold')
	self.color = Color.newFromHex(xmlRoot:GetAttribute('color'), 128)

end

-- COMPARISON ============================================================
-- =======================================================================

function RelationshipStatus.__lt (rs1, rs2)

	assert(isClass(rs1, RelationshipStatus), "Cannot use the RelationshipStatus comparator to compare other classes.")
	assert(isClass(rs2, RelationshipStatus), "Cannot use the RelationshipStatus comparator to compare other classes.")

	return rs1:GetIndex() < rs2:GetIndex()

end

-- EXPOSE ================================================================
-- =======================================================================

function RelationshipStatus:GetID()
	
	return self.ID

end

-- =======================================================================

function RelationshipStatus:GetText()
	
	return self.text

end

-- =======================================================================

function RelationshipStatus:GetIndex()
	
	return self.index

end

-- =======================================================================

function RelationshipStatus:GetThreshold()
	
	return self.threshold

end

-- =======================================================================

function RelationshipStatus:GetColor()
	
	return self.color

end

