
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

RelationshipStatuses = {}
RelationshipStatuses.__index = RelationshipStatuses

-- =======================================================================

function RelationshipStatuses.new (sourceFilePath)

	local new = {}
	setmetatable(new, RelationshipStatuses)
	
	new.statuses = Collection.new()
	new:LoadFromXML(sourceFilePath)

	return new

end

-- =======================================================================

function RelationshipStatuses:LoadFromXML (sourceFilePath)

	local xmlRoot = XmlDocument.newFromFile(sourceFilePath):GetRoot()
	for n, element in xmlRoot:EachElement() do

		local status = RelationshipStatus.new(element, n)
		self.statuses:Add(status)

	end

end

-- =======================================================================

function RelationshipStatuses:GetStatusForValue (value)

	local last = self.statuses:First()
	for status in self.statuses:Each() do

		local threshold = status:GetThreshold()
		if threshold then

			if threshold > value then
				return last
			end

		end

		last = status

	end

	return last

end

-- =======================================================================

function RelationshipStatuses:GetStatus (ID)

	return assert(self.statuses:First(function (s) return s:GetID() == ID end))

end

