
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

RewardFactory = {}
RewardFactory.__index = RewardFactory

-- =======================================================================

function RewardFactory.new()

	local new = {}
	setmetatable(new, RewardFactory)
	
	return new

end

-- =======================================================================

function RewardFactory:NewReward (xmlRoot)
	
	local new
	local class = RewardClass:FromStr(xmlRoot:GetRequiredAttribute('class'))

	if class == RewardClass.Credits then
		new = Reward_Credits.new(xmlRoot)
	end

	if class == RewardClass.Item then
		new = Reward_Item.new(xmlRoot)
	end

	assert(new, strFormat("Cannot create reward with class '%s'.", class:ToStr()))

	new.class = class

	return new

end

