
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Scan = {}
Scan.__index = Scan

-- =======================================================================

function Scan.new (database)

	local new = {}
	setmetatable(new, Scan)
	
	new.mark = 0
	new.database = database

	return new

end

-- =======================================================================

function Scan:ReceiveTimePulse (pulse)

	local database = self.database

	-- Move the mark
	local markSpace = database:GetMarkSpace()
	self.mark = math.min(self.mark + pulse * self:GetMarkSpeed(), markSpace)

	-- Detect data
	for data in database:GetData():Each() do

		if (not data:IsDetected()) and data:GetMark() <= self.mark then

			data:Detect()

		end

	end

end

-- =======================================================================

function Scan:GetMarkSpeed()

	return 256

end

-- =======================================================================

function Scan:IsComplete()

	return self.mark == self.database:GetMarkSpace() 

end

-- =======================================================================

function Scan:GetMark()

	return self.mark

end

