
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

StaticEntities = {}
StaticEntities.__index = StaticEntities

-- =======================================================================

function StaticEntities.new (class, dataFilePath)

	local new = {}
	setmetatable(new, StaticEntities)

	new.entities = Map.new()
	new:Init(class, dataFilePath)
	
	return new

end

-- ... ===================================================================
-- =======================================================================

function StaticEntities:Init (class, dataFilePath)

	local xmlRoot = XmlDocument.newFromFile(dataFilePath):GetRoot()
	for _, element in xmlRoot:EachElement() do

		local ent = class.new(element)

		local ID = ent:GetID()
		assert(not self.entities:ContainsKey(ID), strFormat("Duplicate ID '%s' in the static entities map.", ID))
		self.entities[ID] = ent

	end

end

-- ... ===================================================================
-- =======================================================================

function StaticEntities:Get (ID)

	return assert(self.entities[ID], strFormat("Cannot locate ID '%s' in the static entities map.", ID))

end

