
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz
 
Text = {}
Text.__index = Text

-- =======================================================================

function Text.new (template)

	local new = {}
	setmetatable(new, Text)

	new.template = template

	return new

end

-- =======================================================================

function Text:Evaluate (values)
	
	return self.template:gsub('{(%a-):(.-)}', function (command, params) return self:EvaluateToken(command, params, values) end)

end

-- =======================================================================

function Text:EvaluateToken (command, params, values)

	if command == 'random' then
		return self:EvaluateToken_Random(params)
	end

	if command == 'value' then
		return self:EvaluateToken_Value(params, values)
	end

	return '<invalid>'

end

-- =======================================================================

function Text:EvaluateToken_Random (params)

	local pool = params:explode('|')
	return table.random(pool)

end

-- =======================================================================

function Text:EvaluateToken_Value (params, values)

	local tokens = params:explode(':')

	local valueName = tokens[#tokens]
	local result = values[valueName]

	for n = 1, #tokens-1 do

		local token = tokens[n]
		if token == 'capitalise' then

			result = result:capitaliseFirst()

		end

	end

	return result

end

