
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Tokens = {}
Tokens.__index = Tokens

-- =======================================================================

function Tokens.new (count, max)

	local new = {}
	setmetatable(new, Tokens)
	
	new.count = count
	new.max = max

	return new

end

-- =======================================================================

function Tokens:Add (count)
	
	self.count = math.min(self.count + count, self.max)

end

-- =======================================================================

function Tokens:Remove (count)
	
	self.count = math.max(self.count - count, 0)

end

-- =======================================================================

function Tokens:Clear()
	
	self:Remove(self.count)

end

-- =======================================================================

function Tokens:CanSpend (count)
	
	return self.count >= count

end

-- =======================================================================

function Tokens:GetCount()
	
	return self.count

end

-- =======================================================================

function Tokens:GetMaxCount()
	
	return self.max

end
