
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

TracePoint = {}
TracePoint.__index = TracePoint

-- =======================================================================

function TracePoint.new (trace, node)

	local new = {}
	setmetatable(new, TracePoint)
	
	new.trace = trace
	new.node = node

	return new

end

-- ADVANCE ===============================================================
-- =======================================================================

function TracePoint:StartAdvance()

	self.advance = 0
	self.complete = nil

end

-- TIME ==================================================================
-- =======================================================================

function TracePoint:ReceiveTimePulse (pulse)
	
	if isNumber(self.advance) and (not self.complete) then

		local speed = self.node:GetTraceSpeed() * deck:GetTraceSpeedMod()
		self.advance = math.min(self.advance + pulse*speed, 1)

		if self.advance == 1 then

			self.trace:Spread(self.node)
			self.complete = true

		end

	end

end

-- EXPOSE ================================================================
-- =======================================================================

function TracePoint:GetNode()
	
	return self.node

end

