
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

TraceStarter = {}
TraceStarter.__index = TraceStarter

-- =======================================================================

function TraceStarter.new (network)

	local new = {}
	setmetatable(new, TraceStarter)

	new.network = network
	new.traces = 0

	return new

end

-- CONSTRUCTION ==========================================================
-- =======================================================================

function TraceStarter:LoadFromPlan (plan)
	
	self.durationBase = plan:GetDurationBase()
	self.durationIncrement = plan:GetDurationIncrement()

end

-- ... ===================================================================
-- =======================================================================

function TraceStarter:NewTrace ()

	local duration = self:GetNextTraceDuration()
	return Trace.new(self.network, duration)

end

-- =======================================================================

function TraceStarter:ExtendTrace (trace, node)
	
	local duration = self:GetNextTraceDuration()
	trace:RestartCountdown(duration)

	if not trace:ContainsNode(node) then

		trace:NewPoint(node)

	end

end

-- =======================================================================

function TraceStarter:GetNextTraceDuration()

	self.traces = self.traces + 1
	return self.durationBase + (self.traces-1) * self.durationIncrement

end

