
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Tracker = {}
Tracker.__index = Tracker

-- =======================================================================

function Tracker.new (evasion, duration, network)

	local new = {}
	setmetatable(new, Tracker)
	
	new.countdown = Countdown.new(duration)
	new.network = network

	new:BindEvasion(evasion)

	return new

end

-- CONSTRUCTION ==========================================================
-- =======================================================================

function Tracker:BindEvasion (evasion)

	self.evasion = evasion
	evasion.tracker = self

end

-- EVASION ===============================================================
-- =======================================================================

function Tracker:ReceiveEvasionImpulse (impulse)

	self.evasion:React(impulse)

end

-- TIME ==================================================================
-- =======================================================================

function Tracker:ReceiveTimePulse (pulse)

	self.countdown:ReceiveTimePulse(pulse)
	if self.countdown:IsComplete() then

		self:Complete()

	end

end

-- =======================================================================

function Tracker:Complete()

    eventStarter:ReceiveImpulse(EventImpulse.TrackerComplete, { network = self.network })
	self.network:StopTracker(self)

end

-- EXPOSE ================================================================
-- =======================================================================

function Tracker:GetNetwork()

	return self.network

end

-- =======================================================================

function Tracker:GetEvasion()
	
	return self.evasion

end

-- =======================================================================

function Tracker:GetCountdown()
	
	return self.countdown

end

