
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

TutorialHint = {}
TutorialHint.__index = TutorialHint

-- =======================================================================

function TutorialHint.new (xmlRoot)

	local new = {}
	setmetatable(new, TutorialHint)
	
	new:LoadFromXML(xmlRoot)

	return new

end

-- =======================================================================

function TutorialHint:LoadFromXML (xmlRoot)
	
	self.ID = xmlRoot:GetRequiredAttribute('ID')

	local textElement = assert(xmlRoot:GetElement('text'), "Tutorial hint doesn't contain a <text> attribute.")
	self.text = textElement:GetCleanContent():gsub('|', '\n')

	self.next = xmlRoot:GetAttribute('next')

end

-- ... ===================================================================
-- =======================================================================

function TutorialHint:GetID()
	
	return self.ID

end

-- =======================================================================

function TutorialHint:GetText()
	
	return self.text

end

-- =======================================================================

function TutorialHint:HasNextHint()
	
	return self.next ~= nil

end

-- =======================================================================

function TutorialHint:GetNextHint()
	
	return self.next

end
