
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Tutorials = {}
Tutorials.__index = Tutorials

-- =======================================================================

function Tutorials.new()

	local new = {}
	setmetatable(new, Tutorials)
	
	new.tutorials = Collection.new()
	new:Init()

	return new

end

-- INIT ==================================================================
-- =======================================================================

function Tutorials:Init()
	
	self:InitTutorial('_001')
	self:InitTutorial('_002')
	self:InitTutorial('_003')
	self:InitTutorial('_004')
	self:InitTutorial('_005')

end

-- =======================================================================

function Tutorials:InitTutorial (ID)
	
	local tutorial = Tutorial:NewInstance(ID)
	self.tutorials:Add(tutorial)

end

-- EXPOSE ================================================================
-- =======================================================================

function Tutorials:GetTutorials()
	
	return self.tutorials

end

-- =======================================================================

function Tutorials:GetTutorial (ID)
	
	return assert(self.tutorials:First(function (t) return t:GetID() == ID end))

end
