
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Values = {}

-- =======================================================================

function Values.new (values)

	local new = values or {}
	setmetatable(new, Values)
	
	return new

end

-- =======================================================================

function Values.newFromXML (xmlRoot)

	local new = Values.new()
	for _, element in xmlRoot:EachElement('value') do
	
		local name = assert(element:GetAttribute('name'), "A value doesn't have a name.")
		local value = assert(element:GetAttribute('value'), "A value doesn't have a value.")
		
		new[name] = value
	
	end
	
	return new

end

-- =======================================================================

function Values.__index (values, k)

	return assert(Values[k], strFormat("Values do not contain a value named '%s'.", k))

end

-- =======================================================================

function Values.__add (valuesA, valuesB)

	local result = Values.new(valuesA, valuesB)
	for k, v in valuesB:Each() do
		result[k] = v
	end

	return result

end

-- =======================================================================

function Values:Each()

	return pairs(self)

end

