
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

WeightSet = {}
WeightSet.__index = WeightSet

-- =======================================================================

function WeightSet.new (values)

	local new = {}
	setmetatable(new, WeightSet)
	
	new.wTotal = 0
	new.values = {}
	new.w = {}
	
	if values then
		for value, w in pairs(values) do
			new:Add(value, w)
		end
	end

	return new

end

-- =======================================================================

function WeightSet:Add (value, w)

	table.insert(self.values, value)
	table.insert(self.w, w)
	
	self.wTotal = self.wTotal + w
	
end

-- =======================================================================

function WeightSet:Random()

	local index = 1
	local rand = random:ZeroToOne() * self.wTotal

	local values = self.values
	local w = self.w

	assert(#values > 0, "Cannot pick a random value from an empty weight set.")

	while rand > w[index] do
	
		rand = rand - w[index]
		index = index + 1
	
	end
	
	return values[index]
	
end

-- =======================================================================

function WeightSet:GetItemCount()
	
	return #self.values

end

