
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Color = {}
Color.__index = Color

-- =======================================================================

function Color.newFromRGB (r, g, b, a)

	local new = { r, g, b, a or 255 }
	setmetatable(new, Color)

	return new

end

-- =======================================================================

function Color.newFromHex (str, alpha)

	local chars = '[0-9A-Fa-f]'
	local matchExp = strFormat('#?(%s%s)(%s%s)(%s%s)', chars, chars, chars, chars, chars, chars)
	local rHex, gHex, bHex = str:match(matchExp)
	
	assert(rHex, strFormat("Unable to parse color: '%s'", str))
	
	return Color.newFromRGB(tonumber(rHex, 16), tonumber(gHex, 16), tonumber(bHex, 16), alpha)
	
end

-- =======================================================================

function Color:SetAlpha (alpha)

	self[4] = alpha

end

-- =======================================================================

function Color:GetAlpha()

	return self[4]

end

-- =======================================================================

function Color:SetAsLoveColor (alpha)

	love.graphics.setColor(self[1], self[2], self[3], alpha or self[4])

end

-- =======================================================================

function Color:Packed()

	return { self[1], self[2], self[3], self[4] }

end 
