
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Effects = {}
Effects.__index = Effects

-- =======================================================================

function Effects.new()

	local new = {}
	setmetatable(new, Effects)

	new.effects = Collection.new()
	
	return new

end

-- ... ===================================================================
-- =======================================================================

function Effects:Add (effect)
	
	self.effects:Add(effect)

end

-- DRAW ==================================================================
-- =======================================================================

function Effects:Draw (screenX, screenY)
	
	for e in self.effects:Each() do
		e:Render(screenX, screenY)
	end

end

-- TIME ==================================================================
-- =======================================================================

function Effects:ReceiveTimePulse (pulse)

	for e in self.effects:Each() do
		e:ReceiveTimePulse(pulse)
	end

end

-- TERMINATION ===========================================================
-- =======================================================================

function Effects:RemoveTerminated()
	
	local isTerminated = function (e) return e:IsTerminated() end
	self.effects:RemoveWithPredicate(isTerminated)

end

