
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

EntranceRender = {}
EntranceRender.__index = EntranceRender

-- =======================================================================

setmetatable(EntranceRender, NodeRender)

-- =======================================================================

function EntranceRender.new (node)

	local new = NodeRender.new(node)
	setmetatable(new, EntranceRender)

	return new

end

-- =======================================================================

function EntranceRender:Draw (screenX, screenY)

	self:SetupRenderColor()

	love.graphics.circle('fill', screenX, screenY, 12, 3)
	love.graphics.circle('line', screenX, screenY, 12, 3)

	skin:GetColor('network:node-details'):SetAsLoveColor()

	love.graphics.circle('fill', screenX, screenY, 12-6, 3)
	love.graphics.circle('line', screenX, screenY, 12-6, 3)

	self:DrawFuses(screenX, screenY)

end

-- =======================================================================

function EntranceRender:DrawFuses (screenX, screenY)
	
	local radiusStep = 3
	local radiusBase = 24

	for n, fuse in networkScreen:GetRun():GetFuses():EachIndexed() do

		local radius = radiusBase + (n-1)*radiusStep
		
		love.graphics.setLineWidth(1)
		love.graphics.setColor(232, 232, 232, 32)
		love.graphics.circle('line', screenX, screenY, radius, 12)

	end	

end

