
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Font = {}
Font.__index = Font

-- =======================================================================

function Font.new (sourceFileName, size)

	local new = {}
	setmetatable(new, Font)

	new:Create(sourceFileName, size)

	return new

end

-- =======================================================================

function Font:Create (sourceFileName, size)

	local sourceFilePath = skin:GetFontDir() .. '/' .. sourceFileName
	if not checkFileExists(sourceFilePath) then

		sourceFilePath = 'assets/fonts/' .. sourceFileName
		if not checkFileExists(sourceFilePath) then

			error(strFormat("Font file '%s' cannot be located.", sourceFileName))

		end

	end

	self.font = love.graphics.newFont(sourceFilePath, size)

end

-- =======================================================================

function Font:SetAsLoveFont()
	
	love.graphics.setFont(self.font)

end

-- =======================================================================

function Font:CalculateSize (text, width)
	
	return self.font:getWrap(text, width)

end

-- =======================================================================

function Font:GetHeight()
	
	return self.font:getHeight()

end
