
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

FontFactory = {}
FontFactory.__index = FontFactory

-- =======================================================================

function FontFactory.new()

	local new = {}
	setmetatable(new, FontFactory)

	new.cache = Multimap.new(2)
	
	return new

end

-- =======================================================================

function FontFactory:NewFont (sourceFontFile, size)

	local new = self.cache:Get({ sourceFontFile, size })
	if new == nil then

		new = Font.new(sourceFontFile, size)
		self.cache:Set({ sourceFontFile, size }, new)	

	end

	return new

end

