
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Sprites = {}
Sprites.__index = Sprites

-- =======================================================================

function Sprites.new()

	local new = {}
	setmetatable(new, Sprites)
	
	new.sprites = Map.new()
	new:Load()

	return new

end

-- =======================================================================

function Sprites:Load()

	self:LoadSprite('back_01', 'back/back_hex.png')
	self:LoadSprite('back_event_01', 'back/back_event.png')
	self:LoadSprite('character_man', 'characters/man.png')
	self:LoadSprite('character_woman', 'characters/woman.png')

end

-- =======================================================================

function Sprites:LoadSprite (ID, sourceFilePath)
	
	assert(not self.sprites:ContainsKey(ID), strFormat("Duplicate sprite ID '%s'.", ID))

	local sprite = love.graphics.newImage('assets/sprites/' .. sourceFilePath)
	self.sprites[ID] = sprite

end

-- =======================================================================

function Sprites:GetSprite (ID)

	return assert(self.sprites[ID], strFormat("Sprite with ID '%s' doesn't exist.", ID))

end

