
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

TerminalRender = {}
TerminalRender.__index = TerminalRender

-- =======================================================================

setmetatable(TerminalRender, NodeRender)

-- =======================================================================

function TerminalRender.new (node)

	local new = NodeRender.new(node)
	setmetatable(new, TerminalRender)

	return new

end

-- =======================================================================

function TerminalRender:Draw (screenX, screenY)

	local node = self.node
	local access = node:IsAccessed()
	local radius = 18

	self:SetupRenderColor()

	if access then
		love.graphics.circle('fill', screenX, screenY, radius, 4)
	end

	love.graphics.setLineWidth(1)
	love.graphics.circle('line', screenX, screenY, radius, 4)

	if access then

		skin:GetColor('network:node-details'):SetAsLoveColor()
		love.graphics.circle('line', screenX, screenY, radius - 4, 4)

	end

end

