
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Screen = {}
Screen.__index = Screen

-- =======================================================================

function Screen.new()

	local new = {}
	setmetatable(new, Screen)

	return new

end

-- =======================================================================

function Screen:Draw()

	if not self.screen then
		return
	end

	self.screen:Draw()
	self.screen:DrawPopup()
	self.screen:DrawExplanation()

end

-- =======================================================================

function Screen:Set (screen, context)

	if self.screen then

		self.screen:HideExplanation()
		self.screen:Leave()

	end

	if screen == networkScreen then

		local color = skin:GetColor('network:back')
		love.graphics.setBackgroundColor(color:Packed())

	else

		love.graphics.setBackgroundColor(Color.newFromHex('021D38'):Packed())
		
	end

	if screen ~= self.screen then

		if screen == networkScreen and devConsole:GetVar('music'):IsEnabled() and (not context.tutorial) then
			music:Start()
		end

		if self.screen == networkScreen then
			music:Stop()
		end

	end

	self.screen = screen
	screen:Enter(context)
	screen:Set()

	if screen:HasExplanation() and (not screen:GetExplanation():IsSuppressed()) and (screen ~= networkScreen or (not context.tutorial)) then

		screen:ShowExplanation()
		
	end

end

-- =======================================================================

function Screen:ReceiveTimePulse (pulse)
	
	self.screen:ReceiveTimePulse(pulse)

end

-- =======================================================================

function Screen:GetCurrent()
	
	return self.screen

end

