
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

CreditsScreen = {}
CreditsScreen.__index = CreditsScreen

-- =======================================================================

setmetatable(CreditsScreen, BaseScreen)

-- =======================================================================

CreditsScreen.__static__ = 
{
	
}

-- =======================================================================

function CreditsScreen.new()

	local new = BaseScreen.new()
	setmetatable(new, CreditsScreen)

	return new

end

-- ENTER/LEAVE ===========================================================
-- =======================================================================

function CreditsScreen:Enter (context)

	self:CreateUI()

end

-- =======================================================================

function CreditsScreen:Leave()

	self:RemoveUI()

end

-- CREATE UI =============================================================
-- =======================================================================

function CreditsScreen:CreateUI()

	local windowSizeX = love.window.getWidth()
	local windowSizeY = love.window.getHeight()

	-- Sections
	self.sections = Collection.new()
	self.sections:Add({ title = "Game", text = "mz1"})
	self.sections:Add({ title = "Game Development Framework", text = "LÖVE"})
	self.sections:Add({ title = "LÖVE GUI libraries", text = "Löve Frames [Nikolai Resokav]"})
	self.sections:Add({ title = "Fonts", text = "Infinum Guardian [Axel Lymphos] / Downlink [Neale Davidson] / Exo [Natanael Gama]"})
	self.sections:Add({ title = "Cursor", text = "Black Royale Cursor Pack [killerbeat.deviantart.com] (edited)"})
	self.sections:Add({ title = "Music", text = "www.voho.cz" })

	-- Button
	self.menuButton = loveFrames.Create('button')
	self.menuButton:SetSize(420, 32)
	self.menuButton:SetPos(windowSizeX/2, windowSizeY - 128 - 64, true)
	self.menuButton:SetText("Back to Menu")
	self.menuButton:SetFont('menu-button')

	self.menuButton.OnClick = function()

		screen:Set(menuScreen)

	end

end

-- REMOVE UI =============================================================
-- =======================================================================

function CreditsScreen:RemoveUI()

	self.menuButton:Remove()

end	

-- DRAW ==================================================================
-- =======================================================================

function CreditsScreen:Draw()

	local windowSizeX = love.window.getWidth()
	local windowSizeY = love.window.getHeight()

	self:DrawBackTexture(1)
	self:DrawBackGradient(4, 24, 18, 8, 4)

	love.graphics.setColor(232, 232, 232)
	fonts:GetFont('screen-label'):SetAsLoveFont()
	love.graphics.printf('CREDITS', 0, windowSizeY-80, windowSizeX, 'center')

	for n, section in self.sections:EachIndexed() do

		local posY = windowSizeY - 256 - 64*n

		love.graphics.setColor(192, 192, 232, 232)
		fonts:GetFont('credits-section'):SetAsLoveFont()
		love.graphics.printf(section.title, 0, posY, windowSizeX, 'center')

		love.graphics.setColor(192, 192, 232, 232)
		fonts:GetFont('credits-text'):SetAsLoveFont()
		love.graphics.printf(section.text, 0, posY - 16, windowSizeX, 'center')

	end

	self.menuButton:draw()

end

