
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Countdown = {}
Countdown.__index = Countdown

-- =======================================================================

function Countdown.new (duration)

	local new = {}
	setmetatable(new, Countdown)

	new.countdown = duration
	new.duration = duration
	
	return new

end

-- =======================================================================

function Countdown:ReceiveTimePulse (pulse)

	self.countdown = math.max(self.countdown-pulse, 0)

end

-- =======================================================================

function Countdown:GetCountdown()

	return self.countdown

end

-- =======================================================================

function Countdown:GetRelativeCountdown()

	return self.countdown / self.duration

end

-- =======================================================================

function Countdown:IsComplete()

	return self.countdown == 0

end

