
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Multimap = {}
Multimap.__index = Multimap

-- =======================================================================

function Multimap.new (dimensions)

	local new = {}
	setmetatable(new, Multimap)

	new.values = {}
	new.dimensions = dimensions
	
	return new

end

-- =======================================================================

function Multimap:Set (indices, value)

	assert(#indices == self.dimensions, strFormat("Invalid index count; %d indices expected.", self.dimensions))
	
	local t = self.values
	for n = 1, #indices-1 do
	
		local index = indices[n]
		t[index] = t[index] or {}
		
		t = t[index]
	
	end
	
	local index = indices[#indices]
	t[index] = value

end

-- =======================================================================

function Multimap:Get (indices)

	assert(#indices == self.dimensions, strFormat("Invalid index count; %d indices expected.", self.dimensions))
	
	local t = self.values
	for n = 1, #indices-1 do
	
		local index = indices[n]
		t = t[index]
		
		if t == nil then
			return
		end
	
	end
	
	local index = indices[#indices]
	return t[index]
	
end

