
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local mod = Module:NewClass
{ 
	ID = '{ceee7b53-cb2c-490b-b78c-24d26d0bab08}', 
	name = "Chime", 
	use = ModuleUse.Node,
	nodeClassesLimit = { NodeClass.Router },
	description = "Reveals all subroutines on the selected node and all the connected nodes.",
	traits = { ModuleTrait.Exploit },
	tokens = 0
}

-- =======================================================================

function mod:RunOnNode (node)
	
	self:CreateEffectOnNode('chime-_-center', node)

	for n in node:GetConnectedNodes(NodeClass.Router):Each() do
		self:CreateEffectOnNode('chime-_-leaves', node)
	end

end

-- =======================================================================

mod.handlers['reveal'] = function (self, effect)

	local node = effect:GetPivot()
	
	for subroutine in node:GetSubroutines():Each() do
		subroutine:Reveal()
	end

end

