-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

local tutorial = Tutorial:NewClass
{
	ID = '_005',
	rootDir = '_005',
	name = "Coroutine, Exploit",
}

-- =======================================================================

function tutorial:Init()

	networkScreen:GetNetworkControl():GetCameraControl():SetPos(450, 72.5)

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.Breach] = function (self, context)

	local node = context['node']
	if node:GetID() == 2 then

		self:ShowHint('coroutines-trace')
		return

	end

	if node:GetID() == 8 then

		self:ShowHint('exploit-modules-1')
		return

	end

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.ModuleExecution] = function (self, context)

	local module = context['module']
	if module:GetID() == '{6064bbf6-c071-4718-b882-77f19b549d1e}' and self:GetShownHint():GetID() == 'coroutines-3' then

		self:ShowHint('coroutines-4')
		return

	end

	if module:GetID() == '{0c0a9746-b09e-422f-a1b4-7ae1b6fb0c0f}' then

		self:Finish()
		return

	end

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.HintShow] = function (self, context)

	local ID = context['ID']
	if ID == 'coroutines-5' then

		self:AddModule('{cdf02363-e421-4ec0-8445-d40647549781}')
		return

	end

	if ID == 'exploit-3' then

		self:AddModule('{10b6dbd9-48d5-46a2-9f98-e55c490c765b}')
		return

	end

	if ID == 'exploit-modules-1' then

		self:AddModule('{0c0a9746-b09e-422f-a1b4-7ae1b6fb0c0f}')
		return

	end

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.CoroutineTerminated] = function (self, context)

	if self:GetShownHint():GetID() == 'coroutines-trace' then
	
		self:ShowHint('exploit-1')
		return

	end

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.ExploitExposed] = function (self, context)

	local exploit = context['exploit']
	if exploit:GetHost():GetID() == 8 then

		self:ShowHint('exploit-4')

	end

end

-- =======================================================================

tutorial.reactions[TutorialImpulse.ExploitExploited] = function (self, context)

	local exploit = context['exploit']
	if exploit:GetHost():GetID() == 8 then

		self:ShowHint('exploit-6')

	end

end
