
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Exploit = Entity.new()
Exploit.__index = Exploit

-- =======================================================================

function Exploit:__class_setup__ (params)

	self.description = params.description

end

-- =======================================================================

function Exploit:new (condition, values)

	local new = {}
	setmetatable(new, self)

	new.values = values
	new:SetCondition(condition)

	return new

end

-- ... ===================================================================
-- =======================================================================

function Exploit:SetCondition (condition)
	
	self.condition = condition
	condition.exploit = self

end

-- ... ===================================================================
-- =======================================================================

function Exploit:Expose()
	
	self.expose = true

	networkScreen:ReceiveTutorialImpulse(TutorialImpulse.ExploitExposed, { exploit = self })

end

-- =======================================================================

function Exploit:IsExposed()

	return self.expose

end

-- =======================================================================

function Exploit:ReceiveExposureImpulse (impulse)
	
	if self:IsExposed() then
		return
	end

	if self.condition:React(impulse) then

		self:Expose()

	end

end

-- DESCRIPTION ===========================================================
-- =======================================================================

-- [Exploit classes can override this]
function Exploit:GetDescription()
	
	return self.description

end

-- EXPOSE ================================================================
-- =======================================================================

function Exploit:GetHost()
	
	return self.host

end

-- =======================================================================

function Exploit:GetCondition()
	
	return self.condition

end
