
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

Payload = {}
Payload.__index = Payload

-- =======================================================================

function Payload.new (condition, execution)

	local new = {}
	setmetatable(new, Payload)
	
	new.condition = condition
	new.execution = execution

	return new

end

-- ... ===================================================================
-- =======================================================================

function Payload:BindNetwork (network)
	
	self.condition:BindNetwork(network)

end

-- ... ===================================================================
-- =======================================================================

function Payload:StartExecution()

	self.countdown = Countdown.new(self.execution)

end

-- =======================================================================

function Payload:IsExecuted()
	
	return self.countdown ~= nil

end

-- =======================================================================

function Payload:GetExecutionCountdown()
	
	return self.countdown

end

-- =======================================================================

function Payload:ReceiveTimePulse (pulse)
	
	if self.countdown then

		self.countdown:ReceiveTimePulse(pulse)
		if self.countdown:IsComplete() then

			self.countdown = nil
			self:Complete()

		end

	end

end

-- =======================================================================

function Payload:GetExecutionTime()
	
	return self.execution

end

-- =======================================================================

function Payload:Complete()
	
	self.complete = true

end

-- =======================================================================

function Payload:IsComplete()

	return self.complete

end

-- EXPOSE ================================================================
-- =======================================================================

function Payload:GetCondition()
	
	return self.condition

end

