
-- (c) 2015 Martin Ziegler
-- martin.ziegler@outlook.cz

reqScript = function (script) require('scripts.' .. script) end

-- Consts

reqScript('consts')

-- Console

reqScript('console')

-- Utils

reqScript('utils.collection')
reqScript('utils.countdown')
reqScript('utils.enum')
reqScript('utils.map')
reqScript('utils.multimap')
reqScript('utils.notice')
reqScript('utils.stack')
reqScript('utils.utils')

-- Boot

reqScript('boot')

-- Model

reqScript('model.achievementClass')
reqScript('model.achievementImpulse')
reqScript('model.achievements')
reqScript('model.assets')
reqScript('model.backstories')
reqScript('model.blockableAction')
reqScript('model.character')
reqScript('model.characters')
reqScript('model.chip')
reqScript('model.clause')
reqScript('model.connection')
reqScript('model.console')
reqScript('model.coordinate')
reqScript('model.data')
reqScript('model.dataLabel')
reqScript('model.dataState')
reqScript('model.deck')
reqScript('model.deckAspect')
reqScript('model.deckTrait')
reqScript('model.download')
reqScript('model.downloads')
reqScript('model.evaluatedClause')
reqScript('model.evaluatedNarrative')
reqScript('model.evaluatedReward')
reqScript('model.evaluatedReward_credits')
reqScript('model.evaluatedReward_item')
reqScript('model.evasionImpulse')
reqScript('model.eventChoice')
reqScript('model.eventChoiceDispatcher')
reqScript('model.eventClauseKind')
reqScript('model.eventExposure')
reqScript('model.eventOption')
reqScript('model.eventFormat')
reqScript('model.eventImpulse')
reqScript('model.eventQueue')
reqScript('model.eventQueueItem')
reqScript('model.eventStarter')
reqScript('model.eventTexts')
reqScript('model.explanation')
reqScript('model.explanations')
reqScript('model.explanationText')
reqScript('model.explanationTexts')
reqScript('model.exposureImpulse')
reqScript('model.item')
reqScript('model.itemClass')
reqScript('model.itemCollection')
reqScript('model.luck')
reqScript('model.markImpulse')
reqScript('model.moduleImpulse')
reqScript('model.moduleTrait')
reqScript('model.moduleUse')
reqScript('model.name')
reqScript('model.names')
reqScript('model.narrative')
reqScript('model.network')
reqScript('model.networkBuilder')
reqScript('model.newGameStarter')
reqScript('model.nodeClass')
reqScript('model.nodeVisibility')
reqScript('model.nodeFactory')
reqScript('model.operation')
reqScript('model.operationTarget')
reqScript('model.operationTargetClass')
reqScript('model.organisation')
reqScript('model.payload')
reqScript('model.persistenceLoader')
reqScript('model.persistenceSaver')
reqScript('model.probe')
reqScript('model.relationship')
reqScript('model.relationshipStatus')
reqScript('model.relationshipStatuses')
reqScript('model.reward')
reqScript('model.reward_credits')
reqScript('model.reward_item')
reqScript('model.rewardClass')
reqScript('model.rewardFactory')
reqScript('model.role')
reqScript('model.run')
reqScript('model.scan')
reqScript('model.sex')
reqScript('model.slots')
reqScript('model.state')
reqScript('model.stateCleaner')
reqScript('model.staticEntities')
reqScript('model.subroutineImpulse')
reqScript('model.subroutineTrait')
reqScript('model.text')
reqScript('model.tickdown')
reqScript('model.ticker')
reqScript('model.tokens')
reqScript('model.trace')
reqScript('model.tracePoint')
reqScript('model.traceStarter')
reqScript('model.tracker')
reqScript('model.tutorialHint')
reqScript('model.tutorialImpulse')
reqScript('model.tutorials')
reqScript('model.values')
reqScript('model.worldEvents')

-- Model: Nodes

reqScript('model.node')

reqScript('model.obstacle')

reqScript('model.database')
reqScript('model.entrance')
reqScript('model.gateway')
reqScript('model.pivot')
reqScript('model.router')
reqScript('model.terminal')

-- Model: Entities

reqScript('model.entity')

reqScript('model.achievement')
reqScript('model.backstory')
reqScript('model.characterBuilder')
reqScript('model.coroutine')
reqScript('model.evasion')
reqScript('model.event')
reqScript('model.exploit')
reqScript('model.exposureCondition')
reqScript('model.fuse')
reqScript('model.kernel')
reqScript('model.mark')
reqScript('model.module')
reqScript('model.operationBuilder')
reqScript('model.payloadCondition')
reqScript('model.subroutine')
reqScript('model.tutorial')

-- Mode: Contexts

reqScript('model.invasiveContext')

reqScript('model.breachContext')
reqScript('model.breakContext')

-- Model: Net plans

reqScript('model.netPlan.netPlanConnection')
reqScript('model.netPlan.netPlanExploit')
reqScript('model.netPlan.netPlanNetwork')
reqScript('model.netPlan.netPlanSubroutine')
reqScript('model.netPlan.netPlanTrace')

-- Model: Net plans -- nodes

reqScript('model.netPlan.netPlanNode')

reqScript('model.netPlan.netPlanData')
reqScript('model.netPlan.netPlanDatabase')
reqScript('model.netPlan.netPlanGateway')
reqScript('model.netPlan.netPlanRouter')

-- Entities: Modules

reqScript('entities.modules._001')
reqScript('entities.modules._002')
reqScript('entities.modules._003')
reqScript('entities.modules._004')
reqScript('entities.modules._005')
reqScript('entities.modules._006')
reqScript('entities.modules._007')
reqScript('entities.modules._008')
reqScript('entities.modules._009')
reqScript('entities.modules._010')
reqScript('entities.modules._011')
reqScript('entities.modules._012')
reqScript('entities.modules._013')
reqScript('entities.modules._014')
reqScript('entities.modules._015')
reqScript('entities.modules._016')
reqScript('entities.modules._017')
reqScript('entities.modules._018')
reqScript('entities.modules._019')
reqScript('entities.modules._020')
reqScript('entities.modules._021')
reqScript('entities.modules._022')
reqScript('entities.modules._023')
reqScript('entities.modules._024')
reqScript('entities.modules._025')
reqScript('entities.modules._026')
reqScript('entities.modules._027')
reqScript('entities.modules._028')
reqScript('entities.modules._029')
reqScript('entities.modules._030')
reqScript('entities.modules._031')
reqScript('entities.modules._032')
reqScript('entities.modules._033')
reqScript('entities.modules._034')
reqScript('entities.modules._035')
reqScript('entities.modules._036')
reqScript('entities.modules._037')
reqScript('entities.modules._038')
reqScript('entities.modules._039')
reqScript('entities.modules._040')

-- Entities: Subroutines

reqScript('entities.subroutines.block-vision')
reqScript('entities.subroutines.breach-_-alert')
reqScript('entities.subroutines.breach-_-alert-connected')
reqScript('entities.subroutines.breach-_-lose-all-tokens')
reqScript('entities.subroutines.breach-_-lose-tokens')
reqScript('entities.subroutines.breach-_-trace')
reqScript('entities.subroutines.break-_-alert')
reqScript('entities.subroutines.break-_-alert-connected')
reqScript('entities.subroutines.break-_-lose-all-tokens')
reqScript('entities.subroutines.break-_-lose-tokens')
reqScript('entities.subroutines.break-_-trace')
reqScript('entities.subroutines.coroutine-_-alert')
reqScript('entities.subroutines.coroutine-_-alert-connected')
reqScript('entities.subroutines.coroutine-_-trace')
reqScript('entities.subroutines.lock-module')
reqScript('entities.subroutines.prevent-breach')
reqScript('entities.subroutines.prevent-breach-alerted')
reqScript('entities.subroutines.prevent-break')
reqScript('entities.subroutines.prevent-download')
reqScript('entities.subroutines.spread-trace')

-- Entities: Kernels

reqScript('entities.kernels._001')
reqScript('entities.kernels.tutorial-1')
reqScript('entities.kernels.tutorial-2')
reqScript('entities.kernels.tutorial-3')
reqScript('entities.kernels.tutorial-4')
reqScript('entities.kernels.tutorial-5')

-- Entities: Fuses

reqScript('entities.fuses.reset-tokens')
reqScript('entities.fuses.alert-alerted')

-- Entities: Exploits

reqScript('entities.exploits.clear-alerts-connected')
reqScript('entities.exploits.clear-all-alerts')
reqScript('entities.exploits.clear-all-alerts-connected')
reqScript('entities.exploits.detect-all-nodes')
reqScript('entities.exploits.double-tokens')
reqScript('entities.exploits.reveal-all-subroutines')
reqScript('entities.exploits.reveal-subroutines-connected')
reqScript('entities.exploits.terminate-trace')
reqScript('entities.exploits.tokens')

-- Entities: Exposures

reqScript('entities.exposures.breach')
reqScript('entities.exposures.breach-connected')
reqScript('entities.exposures.break')
reqScript('entities.exposures.break-all')

-- Entities: Coroutines

reqScript('entities.coroutines._010')
reqScript('entities.coroutines._016')
reqScript('entities.coroutines._019')
reqScript('entities.coroutines._032')

-- Entities: Marks

reqScript('entities.marks._010')
reqScript('entities.marks._016')
reqScript('entities.marks._019')
reqScript('entities.marks._032')

-- Entities: Evasions

reqScript('entities.evasions.breach')
reqScript('entities.evasions.reset-tokens')
reqScript('entities.evasions.tokens')

-- Entities: Payload conditions

reqScript('entities.payloads.access-all-node-class')
reqScript('entities.payloads.breach-all')
reqScript('entities.payloads.remove-all-perimeters')

-- Entities: Character templates

reqScript('entities.characters.[utils]')
reqScript('entities.characters.street.data-broker')
reqScript('entities.characters.street.hardware-vendor')
reqScript('entities.characters.street.hustler')
reqScript('entities.characters.street.module-dealer')
reqScript('entities.characters.botched-operation.character')
reqScript('entities.characters.halrow-lamarche.administrator')
reqScript('entities.characters.kita-adachi.executive')
reqScript('entities.characters.shadowrunner.shadowrunner')

-- Entities: Operation builders

reqScript('entities.operations.botched-operation.operation-1')
reqScript('entities.operations.botched-operation.operation-2')
reqScript('entities.operations.botched-operation.operation-3')
reqScript('entities.operations.halrow-lamarche.account-siphon')
reqScript('entities.operations.kita-adachi.competitor-research')
reqScript('entities.operations.kita-adachi.intruder-punishment')
reqScript('entities.operations.shadowrunner.housebreak')
reqScript('entities.operations.shadowrunner.weapon-source-code')

-- Entities: Events

reqScript('entities.events.botched-operation.introduction')
reqScript('entities.events.botched-operation.operation-1-success')
reqScript('entities.events.botched-operation.operation-1-fail')
reqScript('entities.events.botched-operation.operation-2-success')
reqScript('entities.events.botched-operation.operation-2-fail')
reqScript('entities.events.botched-operation.operation-3-success')
reqScript('entities.events.botched-operation.operation-3-fail')
reqScript('entities.events.common.relationship.deteriorate-with-time')
reqScript('entities.events.common.relationship.leave-when-low')
reqScript('entities.events.halrow-lamarche.administrator.create-coordinate')
reqScript('entities.events.halrow-lamarche.administrator.account-siphon.fail')
reqScript('entities.events.halrow-lamarche.administrator.account-siphon.start')
reqScript('entities.events.halrow-lamarche.administrator.account-siphon.success')
reqScript('entities.events.halrow-lamarche.administrator.introduction.administrator')
reqScript('entities.events.kita-adachi.competitor-research.fail')
reqScript('entities.events.kita-adachi.competitor-research.start')
reqScript('entities.events.kita-adachi.competitor-research.success')
reqScript('entities.events.kita-adachi.intruder-punishment.fail')
reqScript('entities.events.kita-adachi.intruder-punishment.start')
reqScript('entities.events.kita-adachi.intruder-punishment.success')
reqScript('entities.events.shadowrunner.housebreak.start')
reqScript('entities.events.shadowrunner.housebreak.success')
reqScript('entities.events.shadowrunner.housebreak.success-_-hit')
reqScript('entities.events.shadowrunner.housebreak.success-_-miss')
reqScript('entities.events.shadowrunner.housebreak.fail')
reqScript('entities.events.shadowrunner.introduction.shadowrunner')
reqScript('entities.events.shadowrunner.introduction.data-broker')
reqScript('entities.events.shadowrunner.weapon-source-code.fail')
reqScript('entities.events.shadowrunner.weapon-source-code.start')
reqScript('entities.events.shadowrunner.weapon-source-code.success')
reqScript('entities.events.street.introduction.data-broker')
reqScript('entities.events.street.introduction.hardware-vendor')
reqScript('entities.events.street.introduction.module-dealer')
reqScript('entities.events.street.introduction.shadowrunner')
reqScript('entities.events.street.introduction.switch')
reqScript('entities.events.vendor.increase-relationship-on-purchase')
reqScript('entities.events.vendor.increase-relationship-when-data-sold')
reqScript('entities.events.vendor.prune-items')
reqScript('entities.events.vendor.stock-items')

-- Entities: Achievements

reqScript('entities.achievements._001')
reqScript('entities.achievements._002')
reqScript('entities.achievements._003')
reqScript('entities.achievements._004')
reqScript('entities.achievements.GAIA')

-- Entities: Backstories

reqScript('entities.backstories.ex-halrow')
reqScript('entities.backstories.good-old-banshee')
reqScript('entities.backstories.irresistible')
reqScript('entities.backstories.rainy-day-fund')
reqScript('entities.backstories.shadow-friend')
reqScript('entities.backstories.street-contacts')
reqScript('entities.backstories.totemic-charm-tattoo')

-- Entities: Tutorials

reqScript('entities.tutorials._001')
reqScript('entities.tutorials._002')
reqScript('entities.tutorials._003')
reqScript('entities.tutorials._004')
reqScript('entities.tutorials._005')

-- Model: Credits

reqScript('model.credits')

-- Random

reqScript('random.networkRandomiser')
reqScript('random.networkRandomDetails')
reqScript('random.weightSet')

-- Screen

reqScript('screens.baseScreen')

reqScript('screens.aspirationsScreen')
reqScript('screens.backstoriesScreen')
reqScript('screens.characterScreen')
reqScript('screens.chipScreen')
reqScript('screens.connectionScreen')
reqScript('screens.consoleScreen')
reqScript('screens.coordinateScreen')
reqScript('screens.creditsScreen')
reqScript('screens.dataScreen')
reqScript('screens.deckScreen')
reqScript('screens.menuScreen')
reqScript('screens.moduleScreen')
reqScript('screens.networkScreen')
reqScript('screens.operationScreen')
reqScript('screens.tutorialsScreen')

-- Render: Skins

reqScript('render.skin')
reqScript('render.skinFontData')

-- Render

reqScript('render.color')

-- Render: Fonts

reqScript('render.font')
reqScript('render.fontFactory')
reqScript('render.fonts')

-- Render: Network

reqScript('render.connectionRender')
reqScript('render.coroutineRender')
reqScript('render.dataRender')
reqScript('render.networkRender')
reqScript('render.nodeRender')
reqScript('render.nodeRenderFactory')
reqScript('render.subroutineRender')
reqScript('render.operationRender')
reqScript('render.tokensRender')
reqScript('render.traceRender')
reqScript('render.trackerRender')

-- Render: Nodes

reqScript('render.databaseRender')
reqScript('render.entranceRender')
reqScript('render.gatewayRender')
reqScript('render.pivotRender')
reqScript('render.routerRender')
reqScript('render.terminalRender')

-- Render: Module

reqScript('render.moduleRender')
reqScript('render.modulesRender')

-- Render: Effect

reqScript('render.effect')
reqScript('render.effectEvent')
reqScript('render.effects')

-- Render: Event panel

reqScript('render.eventPanel')

-- Render: Tutorial

reqScript('render.tutorialRender')

-- Render: Sprites

reqScript('render.sprites')

-- Entities: Effects

reqScript('entities.effects._008')
reqScript('entities.effects._009')
reqScript('entities.effects._030')
reqScript('entities.effects._031-_-center')
reqScript('entities.effects._031-_-leaves')
reqScript('entities.effects._032')
reqScript('entities.effects._033-_-subroutine')
reqScript('entities.effects._033-_-leaves')
reqScript('entities.effects.black-tulip')
reqScript('entities.effects.caspian')
reqScript('entities.effects.cassiopea-_-center')
reqScript('entities.effects.cassiopea-_-leaves')
reqScript('entities.effects.chimaera')
reqScript('entities.effects.chime-_-center')
reqScript('entities.effects.chime-_-leaves')
reqScript('entities.effects.coroutine')
reqScript('entities.effects.DEAD10CC')
reqScript('entities.effects.debaser')
reqScript('entities.effects.endless')
reqScript('entities.effects.excalibur')
reqScript('entities.effects.evo')
reqScript('entities.effects.faerie')
reqScript('entities.effects.helix-_-center')
reqScript('entities.effects.helix-_-leaves')
reqScript('entities.effects.kitami')
reqScript('entities.effects.leviathan')
reqScript('entities.effects.marble')
reqScript('entities.effects.needle')
reqScript('entities.effects.omniport')
reqScript('entities.effects.oracle-_-center')
reqScript('entities.effects.oracle-_-leaves')
reqScript('entities.effects.phaselock')
reqScript('entities.effects.reaper')
reqScript('entities.effects.redthorn')
reqScript('entities.effects.resequencer')
reqScript('entities.effects.siren')
reqScript('entities.effects.spade')
reqScript('entities.effects.spearhead')
reqScript('entities.effects.spectre')
reqScript('entities.effects.stiletto')
reqScript('entities.effects.switchblade')
reqScript('entities.effects.tempest')
reqScript('entities.effects.titan')
reqScript('entities.effects.white-lotus-_-center')
reqScript('entities.effects.white-lotus-_-leaves')

-- Control

reqScript('control.cameraControl')
reqScript('control.keyboard')
reqScript('control.mouse')
reqScript('control.mouseButton')
reqScript('control.mouseEvents')
reqScript('control.networkControl')

-- Audio

reqScript('audio.music')
reqScript('audio.sounds')
reqScript('audio.track')

-- Time

reqScript('time')

-- Screen

reqScript('screen')

-- Console

reqScript('ext.devConsole.devConsole')
reqScript('ext.devConsole.devConsoleCommand')
reqScript('ext.devConsole.devConsoleLine')
reqScript('ext.devConsole.devConsoleLineKind')
reqScript('ext.devConsole.devConsoleVar')

-- LveFrames

reqScript("ext.loveFrames")

-- XML

reqScript('ext.XML.XmlDocument')
reqScript('ext.XML.XmlElement')
reqScript('ext.XML.xmlReader')

-- Random

reqScript("ext.random.random")


-- I/O

reqScript("ext.io.inputFile")
reqScript("ext.io.outputFile")
reqScript("ext.io.utils")

